importPath=string.gsub(getfenv(1)._.Name,"%.Author","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

pluginName="Anthology"
import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

-- load saved settings - we need this in Main because this supports the OptionsWindow
Settings=PatchDataLoad(Turbine.DataScope.Account, pluginName.."Settings")
if Settings==nil then Settings={} end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end
if Settings.MaxID==nil then
	Settings.MaxID=0
end
if Settings.Font==nil then
	Settings.Font=Turbine.UI.Lotro.Font.Verdana18
end
if Settings.FontColor==nil then
	Settings.FontColor=Turbine.UI.Color.White
else
	Settings.FontColor=Turbine.UI.Color(euroNormalize(Settings.FontColor.A),euroNormalize(Settings.FontColor.R),euroNormalize(Settings.FontColor.G),euroNormalize(Settings.FontColor.B))
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color.Black
else
	Settings.BackColor=Turbine.UI.Color(euroNormalize(Settings.BackColor.A),euroNormalize(Settings.BackColor.R),euroNormalize(Settings.BackColor.G),euroNormalize(Settings.BackColor.B))
end
if Settings.HeadingColor==nil then
	Settings.HeadingColor=Turbine.UI.Color.LightBlue
else
	Settings.HeadingColor=Turbine.UI.Color(euroNormalize(Settings.HeadingColor.A),euroNormalize(Settings.HeadingColor.R),euroNormalize(Settings.HeadingColor.G),euroNormalize(Settings.HeadingColor.B))
end
if Settings.LabelColor==nil then
	Settings.LabelColor=Turbine.UI.Color(.843,.698,.227)
else
	Settings.LabelColor=Turbine.UI.Color(euroNormalize(Settings.LabelColor.A),euroNormalize(Settings.LabelColor.R),euroNormalize(Settings.LabelColor.G),euroNormalize(Settings.LabelColor.B))
end
if Settings.TabSelectedColor==nil then
	Settings.TabSelectedColor=Turbine.UI.Color.LightBlue
else
	-- we have to euroNormalize the colors in case the calling plugin doesn't support font colors
	Settings.TabSelectedColor=Turbine.UI.Color(euroNormalize(Settings.TabSelectedColor.A),euroNormalize(Settings.TabSelectedColor.R),euroNormalize(Settings.TabSelectedColor.G),euroNormalize(Settings.TabSelectedColor.B))
end
if Settings.TabUnSelectedColor==nil then
	Settings.TabUnSelectedColor=Turbine.UI.Color(.2,.25,1)
else
	-- we have to euroNormalize the colors in case the calling plugin doesn't support font colors
	Settings.TabUnSelectedColor=Turbine.UI.Color(euroNormalize(Settings.TabUnSelectedColor.A),euroNormalize(Settings.TabUnSelectedColor.R),euroNormalize(Settings.TabUnSelectedColor.G),euroNormalize(Settings.TabUnSelectedColor.B))
end

if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.15,.15,.25)
else
	Settings.TrimColor=Turbine.UI.Color(euroNormalize(Settings.TrimColor.A),euroNormalize(Settings.TrimColor.R),euroNormalize(Settings.TrimColor.G),euroNormalize(Settings.TrimColor.B))
end

if Settings.LanguageEN==nil then
	Settings.LanguageEN=(locale == "en")
end
if Settings.LanguageDE==nil then
	Settings.LanguageDE=(locale == "de")
end
if Settings.LanguageFR==nil then
	Settings.LanguageFR=(locale == "fr")
end
if Settings.Opacity==nil then
	Settings.Opacity=1
else
	Settings.Opacity=euroNormalize(Settings.Opacity)
end

StoryList=PatchDataLoad(Turbine.DataScope.Account, pluginName.."StoryList");
if StoryList==nil then StoryList={} end
for k,v in ipairs(StoryList) do
	if v.ID==nil then
		v.ID=Settings.MaxID+1
		Settings.MaxID=v.ID
	end
	if v.ID>Settings.MaxID then Settings.MaxID=v.ID end
end

authorStory={}
authorStory.Chapters={}

import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."FontSupport")
fontMetric=FontMetric()
fontMetric:SetFont(Settings.Font)
import (importPath.."DebugWindow");
import (importPath.."PopUpDialog");
import (importPath.."IconWindow")
import (importPath.."Settings")
import (importPath.."StorySelect")
import (importPath.."Storyboard")
import (importPath.."ChapterMaint")
import (importPath.."ImageMaint")

getStoryIndexFromID=function(id)
	local index
	for k,v in ipairs(StoryList) do
		if v.ID==id then
			index=k
			break
		end
	end
	return index
end
getNewID=function()
	-- this function will return the first unused ID for a new story. if they are all used sequentially then it returns the next ID
	-- build table of IDs
	local ret=1
	local tmpList={}
	for k,v in ipairs(StoryList) do
		table.insert(tmpList,v.ID)
	end
	if #tmpList>0 then
		-- sort table of IDs
		table.sort(tmpList)
		if tmpList[1]==1 then
			local found=false
			-- find first entry that doesn't match index
			for k,v in ipairs(tmpList) do
				if k~=v then
					ret=k
					found=true
					break
				end
			end
			if not found then
				ret=#tmpList+1
			end
		end
	end
	return ret
end

authorWindow=Turbine.UI.Lotro.Window()
authorWindow:SetResizable(true)
authorWindow:SetMinimumSize(885,310)
local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4

authorWindow:SetOpacity(Settings.Opacity)
authorWindow.SaveStory=false
if Settings.AuthorWindow==nil then
	Settings.AuthorWindow={}
end
if Settings.AuthorWindow.Width==nil then
	Settings.AuthorWindow.Width=(authorWindow:GetMinimumWidth()+(displayWidth-authorWindow:GetMinimumWidth())/2)/displayWidth
else
	Settings.AuthorWindow.Width=euroNormalize(Settings.AuthorWindow.Width)
end
if Settings.AuthorWindow.Height==nil then
	Settings.AuthorWindow.Height=(authorWindow:GetMinimumHeight()+(displayHeight-authorWindow:GetMinimumHeight())/2)/displayHeight
else
	Settings.AuthorWindow.Height=euroNormalize(Settings.AuthorWindow.Height)
end
if Settings.AuthorWindow.Top==nil then
	Settings.AuthorWindow.Top=(1-Settings.AuthorWindow.Height)/2
else
	Settings.AuthorWindow.Top=euroNormalize(Settings.AuthorWindow.Top)
end
if Settings.AuthorWindow.Left==nil then
	Settings.AuthorWindow.Left=(1-Settings.AuthorWindow.Height)/2
else
	Settings.AuthorWindow.Left=euroNormalize(Settings.AuthorWindow.Left)
end
if Settings.AuthorWindow.Width<(authorWindow:GetMinimumWidth()/displayWidth) then Settings.AuthorWindow.Width=authorWindow:GetMinimumWidth()/displayWidth end
if Settings.AuthorWindow.Height<(authorWindow:GetMinimumHeight()/displayHeight) then Settings.AuthorWindow.Height=authorWindow:GetMinimumHeight()/displayWidth end
if Settings.LoadLastStory==nil then Settings.LoadLastStory=true end

if Settings.AuthorStoryID==nil and Settings.LoadLastStory and Settings.AuthorWindow.LastStory~=nil then
	authorWindow.currentStoryID=Settings.AuthorWindow.LastStory
	authorStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..authorWindow.currentStoryID)
elseif Settings.AuthorStoryID~=nil then
	authorWindow.currentStoryID=Settings.AuthorStoryID
	authorStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..authorWindow.currentStoryID)
end
if authorStory==nil then authorStory={} end
--***
if authorStory.DefaultImagePath==nil then
	authorStory.DefaultImagePath=storyPath
end
Settings.DefaultImagePath=authorStory.DefaultImagePath

authorWindow:SetSize(Settings.AuthorWindow.Width*displayWidth,Settings.AuthorWindow.Height*displayHeight)
authorWindow:SetPosition(Settings.AuthorWindow.Left*displayWidth,Settings.AuthorWindow.Top*displayHeight)

authorWindow:SetText(Resource[language][2].." - "..Resource[language][4])
authorWindow.Closed=function()
	iconWindow:SetVisible(true)
end

authorWindow.ControlPanel=Turbine.UI.Control()
authorWindow.ControlPanel:SetMouseVisible(false); -- so it doesn't mask the window close button
authorWindow.ControlPanel:SetParent(authorWindow)
authorWindow.ControlPanel:SetSize(authorWindow:GetWidth(),65)
authorWindow.ControlPanel:SetPosition(0,0)
authorWindow.ControlPanel:SetBackColor(0,0,0)
authorWindow.CreateNewButton=Turbine.UI.Lotro.Button()
authorWindow.CreateNewButton:SetParent(authorWindow.ControlPanel)
authorWindow.CreateNewButton:SetHeight(20)
authorWindow.CreateNewButton:SetPosition(10,45)
authorWindow.CreateNewButton.Click=function()
	authorWindow.Message:SetText("")
	authorWindow.currentStoryID=nil
	authorWindow.NewActiveChapter=nil
	authorWindow.SetChangedState(false)
	authorWindow.MainTab:MouseClick()
	authorWindow.AuthorName:SetText(localPlayer:GetName())
	authorWindow.StoryName:SetText("")
end
authorWindow.EditExistingButton=Turbine.UI.Lotro.Button()
authorWindow.EditExistingButton:SetParent(authorWindow.ControlPanel)
authorWindow.EditExistingButton:SetHeight(20)
authorWindow.EditExistingButton:SetTop(authorWindow.CreateNewButton:GetTop())
authorWindow.EditExistingButton.Click=function()
	authorWindow.Message:SetText("")
	storySelect.currentStoryID=authorWindow.currentStoryID
	storySelect.ReturnSelected=authorWindow.StorySelected
	storySelect.FillStoryList(storySelect.StoryListBox.SortColumn) -- refresh story list in case a story has been started or stopped
	storySelect:SetVisible(true)
	authorWindow.MouseMask:SetMouseVisible(true) -- note, MouseMask is used to simulate modal dialogs
end

authorWindow.StoryboardButton=Turbine.UI.Lotro.Button()
authorWindow.StoryboardButton:SetParent(authorWindow.ControlPanel)
authorWindow.StoryboardButton:SetHeight(20)
authorWindow.StoryboardButton:SetTop(authorWindow.CreateNewButton:GetTop())
authorWindow.StoryboardButton.Click=function()
	Storyboard:SetVisible(true)
	Storyboard:SetStory()
end

authorWindow.ResetButton=Turbine.UI.Lotro.Button()
authorWindow.ResetButton:SetParent(authorWindow.ControlPanel)
authorWindow.ResetButton:SetHeight(20)
authorWindow.ResetButton:SetTop(authorWindow.CreateNewButton:GetTop())
authorWindow.ResetButton.Click=function()
	authorWindow.Message:SetText("")
	if authorWindow.currentStoryID==nil then
		authorWindow.CreateNewButton.Click()
	else
		authorWindow.SaveStory=false
		SaveSetting("Account",pluginName.."Settings","","Reloading",true) -- set the "reloading" flag to suppress repetitive warnings on load
		SaveSetting("Account",pluginName.."Settings","","AuthorStoryID",authorWindow.currentStoryID) -- save story id
		SaveSetting("Account",pluginName.."Settings","","Mode","Author") -- trigger reload
		SaveSettings()
		SettingQueueCallback(loadMenu)
	end
	authorWindow.MainTab.MouseClick()
end

authorWindow.SaveButton=Turbine.UI.Lotro.Button()
authorWindow.SaveButton:SetParent(authorWindow.ControlPanel)
authorWindow.SaveButton:SetHeight(20)
authorWindow.SaveButton:SetTop(authorWindow.CreateNewButton:GetTop())
authorWindow.SaveButton.Click=function()

-- set window to reload, but in unload, save the story
--***
	authorWindow.SaveStory=true
	-- verify non-blank data for required fields
	-- save the current info as a plugindata file...
	authorStory.Author=authorWindow.AuthorName:GetText()
	authorStory.Name=authorWindow.StoryName:GetText()
	authorStory.Desc=authorWindow.StoryDesc:GetText()
	authorStory.DefaultImagePath=authorWindow.DefaultImagePath:GetText()

	local index=getStoryIndexFromID(authorWindow.currentStoryID)
	if authorWindow.currentStoryID==nil or index==nil then
		-- create a new entry in StoryList
		authorWindow.currentStoryID=getNewID()
		if authorWindow.currentStoryID>Settings.MaxID then
			Settings.MaxID=authorWindow.currentStoryID
		end
		table.insert(StoryList,{["ID"]=authorWindow.currentStoryID,["Author"]=authorStory.Author,["Name"]=authorStory.Name,["Desc"]=authorStory.Desc})
		index=#StoryList
		local item=Turbine.UI.Control()
		item.ID=authorWindow.currentStoryID
		item:SetParent(storySelect.StoryList)
		item:SetSize(storySelect.StoryList:GetWidth(),20)
		item.Author=Turbine.UI.Label()
		item.Author:SetParent(item)
		item.Author:SetSize(storySelect.AuthorHeader:GetWidth(),20)
		item.Author:SetFont(Settings.Font)
		item.Author:SetText(authorStory.Author)
		item.Author:SetMouseVisible(false)
		item.Name=Turbine.UI.Label()
		item.Name:SetParent(item)
		item.Name:SetSize(storySelect.NameHeader:GetWidth(),20)
		item.Name:SetLeft(storySelect.NameHeader:GetLeft())
		item.Name:SetFont(Settings.Font)
		item.Name:SetText(authorStory.Name)
		item.Name:SetMouseVisible(false)
		item.Desc=Turbine.UI.Label()
		item.Desc:SetParent(item)
		item.Desc:SetSize(storySelect.DescHeader:GetWidth(),20)
		item.Desc:SetLeft(storySelect.DescHeader:GetLeft())
		item.Desc:SetFont(Settings.Font)
		item.Desc:SetText(authorStory.Desc)
		item.Desc:SetMouseVisible(false)
		item.MouseDoubleClick=function(sender,args)
			storySelect.StoryListBox:SetSelectedItem(sender)
			storySelect.Select:Click()
		end
		storySelect.StoryListBox:AddItem(item)
		storySelect.StoryListBox:SetSelectedItem(item)
		authorWindow.ChapterNewButton:SetEnabled(true)
	else
		StoryList[index].Author=authorStory.Author
		StoryList[index].Name=authorStory.Name
		StoryList[index].Desc=authorStory.Desc
		StoryList[index].ActiveChapter=authorWindow.NewActiveChapter
		storySelect.StoryListBox:SetSelectedIndex(index)
		local item=storySelect.StoryListBox:GetSelectedItem()
		item.Author:SetText(authorStory.Author)
		item.Name:SetText(authorStory.Name)
		item.Desc:SetText(authorStory.Desc)
	end
	-- now call SaveSetting for all the data so it gets saved in real-time
	authorStory.LastEditTime=Turbine.Engine:GetLocalTime()

	SaveSetting("Account",pluginName.."Settings","","Reloading",true) -- set the "reloading" flag to suppress repetitive warnings on load
	SaveSetting("Account",pluginName.."Settings","","AuthorStoryID",authorWindow.currentStoryID) -- save story id
	SaveSetting("Account",pluginName.."Settings","","Mode","Author") -- trigger reload
	SaveSettings()
	SettingQueueCallback(loadMenu)
end
authorWindow.SaveButton:SetEnabled(false)

authorWindow.MenuButton=Turbine.UI.Lotro.Button()
authorWindow.MenuButton:SetParent(authorWindow.ControlPanel)
authorWindow.MenuButton:SetHeight(20)
authorWindow.MenuButton:SetTop(authorWindow.CreateNewButton:GetTop())
authorWindow.MenuButton.Click=function()
	authorWindow.Message:SetText("")
	-- need a reminder to save dialog
	if authorWindow.StoryChanged then
		authorWindow.MouseMask:SetMouseVisible(true)
		confirmExit=PopUpDialog(Resource[language][35],Resource[language][36],1,Resource[language][32],Resource[language][19],nil,false,authorWindow.ExitOK)
	else
		authorWindow.ExitOK(1)
	end
end
authorWindow.ExitOK=function(flag)
	authorWindow.MouseMask:SetMouseVisible(false)
	confirmExit=nil
	if flag==1 then
		-- reset state
		SaveSetting("Account",pluginName.."Settings","","Reloading",nil) -- set the "reloading" flag to suppress repetitive warnings on load
		SaveSetting("Account",pluginName.."Settings","","Mode","Menu") -- trigger reload
		SaveSettings()
		SettingQueueCallback(loadMenu)
	end
end

authorWindow.StorySelected=function()
	SaveSetting("Account",pluginName.."Settings","","Reloading",nil) -- set the "reloading" flag to suppress repetitive warnings on load
	SaveSetting("Account",pluginName.."Settings","","AuthorStoryID",storySelect.SelectedID) -- save story id
	SaveSetting("Account",pluginName.."Settings","","Mode","Author") -- trigger reload
	SaveSettings()
	SettingQueueCallback(loadMenu)
end

authorWindow.MainTab=Turbine.UI.Label()
authorWindow.MainTab:SetParent(authorWindow)
authorWindow.MainTab:SetPosition(10,76)
authorWindow.MainTab.Underscore=Turbine.UI.Control()
authorWindow.MainTab.Underscore:SetParent(authorWindow.MainTab)
authorWindow.MainTab.Underscore:SetBlendMode(Turbine.UI.BlendMode.Overlay)
authorWindow.MainTab.Underscore:SetLeft(0)
authorWindow.MainTab.Underscore:SetHeight(1)
authorWindow.MainTab.Underscore:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
authorWindow.MainTab.Selected=true
authorWindow.MainTab.MouseClick=function(sender,args)
	authorWindow.MainPanel:SetVisible(true)
	authorWindow.MainTab.Selected=true
	authorWindow.ChapterTab.Selected=false
	authorWindow.MainTab.Underscore:SetBackground(resourcePath.."dot.tga")
	authorWindow.MainTab:SetForeColor(Settings.TabSelectedColor)
	authorWindow.ChapterPanel:SetVisible(false)
	authorWindow.ChapterTab.Underscore:SetBackground(nil)
	authorWindow.ChapterTab:SetForeColor(Settings.TabUnSelectedColor)
end

authorWindow.ChapterTab=Turbine.UI.Label()
authorWindow.ChapterTab:SetParent(authorWindow)
authorWindow.ChapterTab:SetPosition(authorWindow.MainTab:GetLeft()+authorWindow.MainTab:GetWidth()+5,authorWindow.MainTab:GetTop())
authorWindow.ChapterTab.Underscore=Turbine.UI.Control()
authorWindow.ChapterTab.Underscore:SetParent(authorWindow.ChapterTab)
authorWindow.ChapterTab.Underscore:SetBlendMode(Turbine.UI.BlendMode.Overlay)
authorWindow.ChapterTab.Underscore:SetLeft(0)
authorWindow.ChapterTab.Underscore:SetHeight(1)
authorWindow.ChapterTab.Underscore:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
authorWindow.ChapterTab.Selected=false
authorWindow.ChapterTab.MouseClick=function(sender,args)
	authorWindow.ChapterTab.Selected=true
	authorWindow.MainTab.Selected=false
	authorWindow.MainPanel:SetVisible(false)
	authorWindow.MainTab.Underscore:SetBackground(nil)
	authorWindow.MainTab:SetForeColor(Settings.TabUnSelectedColor)
	authorWindow.ChapterPanel:SetVisible(true)
	authorWindow.ChapterTab.Underscore:SetBackground(resourcePath.."dot.tga")
	authorWindow.ChapterTab:SetForeColor(Settings.TabSelectedColor)
end
authorWindow.CloseInfo=function()
	authorWindow.MouseMask:SetMouseVisible(false)
	infoPopUp=nil
end
authorWindow.MainPanel=Turbine.UI.Control()
authorWindow.MainPanel:SetParent(authorWindow)
authorWindow.MainPanel:SetLeft(0)
authorWindow.MainPanel:SetVisible(true)
authorWindow.AuthorNameCaption=Turbine.UI.Label()
authorWindow.AuthorNameCaption:SetParent(authorWindow.MainPanel)
authorWindow.AuthorNameCaption:SetLeft(10)
authorWindow.AuthorName=Turbine.UI.Lotro.TextBox()
authorWindow.AuthorName:SetParent(authorWindow.MainPanel)
authorWindow.AuthorName:SetMultiline(false)
authorWindow.AuthorName:SetText(localPlayer:GetName())
authorWindow.AuthorName.KeyDown=function(sender,args)
	if args.Action==75 then
		authorWindow.SetChangedState(true)
	end
end
authorWindow.AuthorName.TextChanged=function()
	authorWindow.SetChangedState(true)
end

authorWindow.StoryNameCaption=Turbine.UI.Label()
authorWindow.StoryNameCaption:SetParent(authorWindow.MainPanel)
authorWindow.StoryNameCaption:SetLeft(authorWindow.AuthorNameCaption:GetLeft())
authorWindow.StoryName=Turbine.UI.Lotro.TextBox()
authorWindow.StoryName:SetParent(authorWindow.MainPanel)
authorWindow.StoryName:SetMultiline(false)
authorWindow.StoryName.KeyDown=function(sender,args)
	if args.Action==75 then
		authorWindow.SetChangedState(true)
	end
end
authorWindow.StoryName.TextChanged=function()
	authorWindow.SetChangedState(true)
end

authorWindow.LanguageCaption=Turbine.UI.Label()
authorWindow.LanguageCaption:SetParent(authorWindow.MainPanel)
authorWindow.LanguageCaption:SetLeft(authorWindow.AuthorNameCaption:GetLeft())
authorWindow.EN=Turbine.UI.Lotro.CheckBox()
authorWindow.EN:SetParent(authorWindow.MainPanel)
authorWindow.EN:SetChecked(locale=="en")
authorWindow.EN.CheckedChanged=function()
	authorStory.EN=authorWindow.EN:IsChecked()
	authorWindow.SetChangedState(true)
end
authorWindow.DE=Turbine.UI.Lotro.CheckBox()
authorWindow.DE:SetParent(authorWindow.MainPanel)
authorWindow.DE:SetChecked(locale=="de")
authorWindow.DE.CheckedChanged=function()
	authorStory.DE=authorWindow.DE:IsChecked()
	authorWindow.SetChangedState(true)
end
authorWindow.FR=Turbine.UI.Lotro.CheckBox()
authorWindow.FR:SetParent(authorWindow.MainPanel)
authorWindow.FR:SetChecked(locale=="fr")
authorWindow.FR.CheckedChanged=function()
	authorStory.FR=authorWindow.FR:IsChecked()
	authorWindow.SetChangedState(true)
end

authorWindow.DefaultImagePathCaption=Turbine.UI.Label()
authorWindow.DefaultImagePathCaption:SetParent(authorWindow.MainPanel)
authorWindow.DefaultImagePathCaption:SetLeft(authorWindow.AuthorNameCaption:GetLeft())
authorWindow.DefaultImagePath=Turbine.UI.Lotro.TextBox()
authorWindow.DefaultImagePath:SetParent(authorWindow.MainPanel)
authorWindow.DefaultImagePath:SetMultiline(false)
authorWindow.DefaultImagePath:SetText(Settings.DefaultImagePath)
authorWindow.DefaultImagePath.KeyDown=function(sender,args)
	if args.Action==75 then
		authorWindow.DefaultImagePath.TextChanged()
	end
end
authorWindow.DefaultImagePath.TextChanged=function()
	Settings.DefaultImagePath=authorWindow.DefaultImagePath:GetText()
	authorWindow.SetChangedState(true)
end


authorWindow.StoryDescCaption=Turbine.UI.Label()
authorWindow.StoryDescCaption:SetParent(authorWindow.MainPanel)
authorWindow.StoryDescCaption:SetLeft(authorWindow.AuthorNameCaption:GetLeft())
authorWindow.StoryDescBack=Turbine.UI.Control() --bogus 1 pixel border for textbox
authorWindow.StoryDescBack:SetParent(authorWindow.MainPanel)
authorWindow.StoryDesc=Turbine.UI.TextBox() -- note, the Turbine.UI.Lotro.TextBox control doesn't actually support scrolling for some bizare reason
authorWindow.StoryDesc:SetParent(authorWindow.StoryDescBack)
authorWindow.StoryDesc:SetPosition(1,1)
authorWindow.StoryDesc:SetSize(authorWindow.StoryDescBack:GetWidth()-2,authorWindow.StoryDescBack:GetHeight()-2)
authorWindow.StoryDesc:SetBackColor(Turbine.UI.Color.Black)
authorWindow.StoryDesc:SetFont(Settings.Font)
authorWindow.StoryDesc:SetSelectable(true)
authorWindow.StoryDesc.KeyDown=function(sender,args)
	if args.Action==75 then
		authorWindow.SetChangedState(true)
	end
end
authorWindow.StoryDesc.TextChanged=function()
	authorWindow.SetChangedState(true)
end
authorWindow.StoryDescVScroll=Turbine.UI.Lotro.ScrollBar()
authorWindow.StoryDescVScroll:SetParent(authorWindow.MainPanel)
authorWindow.StoryDescVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
authorWindow.StoryDescVScroll:SetWidth(10)
authorWindow.StoryDesc:SetVerticalScrollBar(authorWindow.StoryDescVScroll)

authorWindow.ChapterPanel=Turbine.UI.Control()
authorWindow.ChapterPanel:SetParent(authorWindow)
authorWindow.ChapterPanel:SetLeft(0)
authorWindow.ChapterPanel:SetVisible(false)

-- create a chapter list with Move Up, New, Edit, Copy, Delete, and Move Down buttons
-- chapters are displayed by DisplayIndex and identified by ID (the table index)
-- Buttons are a fixed 120 character width, the list expands with window resizes - the window minimum width is based on the height of this panel due to the buttons

authorWindow.ChapterListBorder=Turbine.UI.ListBox()
authorWindow.ChapterListBorder:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterListBorder:SetSize(authorWindow.ChapterPanel:GetWidth()-35-120, authorWindow.ChapterPanel:GetHeight()) -- 25 for spaces, 120 for button width
authorWindow.ChapterListBorder:SetBackColor(Settings.TrimColor)
authorWindow.ChapterListBorder:SetPosition(10,0)

authorWindow.ChapterList=Turbine.UI.ListBox()
authorWindow.ChapterList:SetParent(authorWindow.ChapterListBorder)
authorWindow.ChapterList:SetSize(authorWindow.ChapterListBorder:GetWidth()-12, authorWindow.ChapterListBorder:GetHeight()-2) -- leave 10 for scrollbar
authorWindow.ChapterList:SetBackColor(Settings.BackColor)
authorWindow.ChapterList:SetPosition(1,1)
authorWindow.ChapterList.LastSelected=nil

authorWindow.ChapterListVScroll=Turbine.UI.Lotro.ScrollBar()
authorWindow.ChapterListVScroll:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterListVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
authorWindow.ChapterListVScroll:SetSize(10,authorWindow.ChapterListBorder:GetHeight())
authorWindow.ChapterListVScroll:SetPosition(authorWindow.ChapterListBorder:GetLeft()+authorWindow.ChapterListBorder:GetWidth(),authorWindow.ChapterListBorder:GetTop())
authorWindow.ChapterList:SetVerticalScrollBar(authorWindow.ChapterListVScroll)

authorWindow.ChapterList.SelectedIndexChanged=function(sender,args)
	local newIndex=authorWindow.ChapterList:GetSelectedIndex()
	if authorWindow.ChapterList.LastSelected~=nil then
		tmpItem=authorWindow.ChapterList:GetItem(authorWindow.ChapterList.LastSelected)
		if tmpItem~=nil then
			tmpItem:SetBackColor(nil)
		end
	end
	authorWindow.ChapterList.LastSelected=authorWindow.ChapterList:GetSelectedIndex()
	tmpItem=authorWindow.ChapterList:GetItem(authorWindow.ChapterList.LastSelected)
	if tmpItem~=nil then
		tmpItem:SetBackColor(Turbine.UI.Color(0,.1,.2))
	end
	
	if newIndex<1 then
		authorWindow.ChapterUpButton:SetEnabled(false)
		authorWindow.ChapterEditButton:SetEnabled(false)
		authorWindow.ChapterCopyButton:SetEnabled(false)
		authorWindow.ChapterDeleteButton:SetEnabled(false)
		authorWindow.ChapterDownButton:SetEnabled(false)
	elseif newIndex==1 then
		authorWindow.ChapterUpButton:SetEnabled(false)
		authorWindow.ChapterEditButton:SetEnabled(true)
		authorWindow.ChapterCopyButton:SetEnabled(true)
		authorWindow.ChapterDeleteButton:SetEnabled(true)
		if authorWindow.ChapterList:GetItemCount()>1 then
			authorWindow.ChapterDownButton:SetEnabled(true)
		else
			authorWindow.ChapterDownButton:SetEnabled(false)
		end
	elseif newIndex==authorWindow.ChapterList:GetItemCount() then
		authorWindow.ChapterUpButton:SetEnabled(true)
		authorWindow.ChapterEditButton:SetEnabled(true)
		authorWindow.ChapterCopyButton:SetEnabled(true)
		authorWindow.ChapterDeleteButton:SetEnabled(true)
		authorWindow.ChapterDownButton:SetEnabled(false)
	else
		authorWindow.ChapterUpButton:SetEnabled(true)
		authorWindow.ChapterEditButton:SetEnabled(true)
		authorWindow.ChapterCopyButton:SetEnabled(true)
		authorWindow.ChapterDeleteButton:SetEnabled(true)
		authorWindow.ChapterDownButton:SetEnabled(true)
	end
end

authorWindow.ChapterUpButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterUpButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterUpButton:SetSize(120,20)
authorWindow.ChapterUpButton:SetPosition(authorWindow.ChapterPanel:GetWidth()-130,5)
authorWindow.ChapterUpButton:SetFont(Settings.Font)
authorWindow.ChapterUpButton:SetText(Resource[language][25])
authorWindow.ChapterUpButton:SetEnabled(false)
authorWindow.ChapterUpButton.Click=function(sender,args)
	-- swap this line's DisplayOrder with the one above it then reload the list
	swapChapterDisplay(authorWindow.ChapterList.LastSelected,authorWindow.ChapterList.LastSelected-1)
	authorLoadObjChapterList()
	authorWindow.SetChangedState(true)
end
authorWindow.ChapterNewButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterNewButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterNewButton:SetSize(120,20)
authorWindow.ChapterNewButton:SetPosition(authorWindow.ChapterUpButton:GetLeft(),authorWindow.ChapterUpButton:GetTop()+authorWindow.ChapterUpButton:GetHeight()+5)
authorWindow.ChapterNewButton:SetFont(Settings.Font)
authorWindow.ChapterNewButton:SetText(Resource[language][26])
authorWindow.ChapterNewButton:SetEnabled(true)
authorWindow.ChapterNewButton.Click=function()
	-- create a new chapter in authorStory.Chapters with name="new" then add it in list after currently selected (or at end if none selected)
	local newID=#authorStory.Chapters+1
	local newChapter={}
	newChapter.Name=Resource[language][26]
	newChapter.Content={}
	table.insert(authorStory.Chapters,newChapter)
	local tmpItem=Turbine.UI.Label()
	tmpItem.ID=newID
	tmpItem:SetParent(authorWindow.ChapterList)
	tmpItem:SetSize(authorWindow.ChapterList:GetWidth(),controlHeight)
	tmpItem:SetFont(Settings.Font)
	tmpItem:SetForeColor(Settings.FontColor)
	tmpItem:SetText(Resource[language][26])
	local tmpIndex=authorWindow.ChapterList:GetSelectedIndex()
	if authorWindow.ChapterList.LastSelected~=nil then
		local tmpItem2=authorWindow.ChapterList:GetItem(authorWindow.ChapterList.LastSelected)
		if tmpItem2~=nil then
			tmpItem2:SetBackColor(nil)
		end
		tmpIndex=tmpIndex+1
	end
	if tmpIndex==0 then
		tmpIndex=authorWindow.ChapterList:GetItemCount()+1
		authorWindow.ChapterList:AddItem(tmpItem)
	else
		for index=tmpIndex, authorWindow.ChapterList:GetItemCount() do
			local item=authorWindow.ChapterList:GetItem(index)
			item.Index=item.Index+1
			authorStory.Chapters[item.ID].DisplayOrder=index+1
		end
		authorWindow.ChapterList:InsertItem(tmpIndex,tmpItem)
	end
	authorStory.Chapters[newID].DisplayOrder=tmpIndex
	authorStory.Chapters[newID].Objectives={}
	tmpItem.Index=tmpIndex
	tmpItem.MouseDoubleClick=function(sender,args)
		authorWindow.ChapterList:SetSelectedIndex(sender.Index)
		authorWindow.ChapterEditButton.Click()
	end
	authorWindow.ChapterList:SetSelectedIndex(tmpIndex)
	authorWindow.SetChangedState(true)
	authorWindow.ChapterEditButton.Click()

	chapterMaint.ObjectiveNextChapter:AddItem(Resource[language][26],newID)
	chapterMaint.SuccessNextChapter:AddItem(Resource[language][26],newID)
	chapterMaint.FailNextChapter:AddItem(Resource[language][26],newID)

--	chapterMaint.ClearChapter()
--	chapterMaint:SetVisible(true)
--	chapterMaint.ChapterName:SetText(Resource[language][26])
--	chapterMaint.SaveButton.Click()
end

authorWindow.ChapterEditButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterEditButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterEditButton:SetSize(120,20)
authorWindow.ChapterEditButton:SetPosition(authorWindow.ChapterUpButton:GetLeft(),authorWindow.ChapterNewButton:GetTop()+authorWindow.ChapterUpButton:GetHeight()+5)
authorWindow.ChapterEditButton:SetFont(Settings.Font)
authorWindow.ChapterEditButton:SetText(Resource[language][10])
authorWindow.ChapterEditButton:SetEnabled(false)
authorWindow.ChapterEditButton.Click=function()
	chapterMaint.SetChapter(authorWindow.ChapterList:GetSelectedItem().ID)
	chapterMaint:SetVisible(true)
	authorWindow.MouseMask:SetMouseVisible(true)
end

authorWindow.ChapterCopyButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterCopyButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterCopyButton:SetSize(120,20)
authorWindow.ChapterCopyButton:SetPosition(authorWindow.ChapterUpButton:GetLeft(),authorWindow.ChapterEditButton:GetTop()+authorWindow.ChapterUpButton:GetHeight()+5)
authorWindow.ChapterCopyButton:SetFont(Settings.Font)
authorWindow.ChapterCopyButton:SetText(Resource[language][27])
authorWindow.ChapterCopyButton:SetEnabled(false)
authorWindow.ChapterCopyButton.Click=function()
	local newID=#authorStory.Chapters+1
	table.insert(authorStory.Chapters,Table.Copy(authorStory.Chapters[authorWindow.ChapterList:GetSelectedItem().ID]))
	authorStory.Chapters[newID].Name=authorStory.Chapters[newID].Name.." - "..Resource[language][47]
	if authorStory.Chapters[newID].X==nil then
		authorStory.Chapters[newID].X=0
	else
		authorStory.Chapters[newID].X=authorStory.Chapters[newID].X+50
	end
	if authorStory.Chapters[newID].Y==nil then
		authorStory.Chapters[newID].Y=0
	else
		authorStory.Chapters[newID].Y=authorStory.Chapters[newID].Y+50
	end
	local tmpItem=Turbine.UI.Label()
	tmpItem.ID=newID
	tmpItem:SetParent(authorWindow.ChapterList)
	tmpItem:SetSize(authorWindow.ChapterList:GetWidth(),controlHeight)
	tmpItem:SetFont(Settings.Font)
	tmpItem:SetForeColor(Settings.FontColor)
	tmpItem:SetText(authorStory.Chapters[newID].Name)
	local tmpIndex=authorWindow.ChapterList:GetSelectedIndex()
	if authorWindow.ChapterList.LastSelected~=nil then
		local tmpItem2=authorWindow.ChapterList:GetItem(authorWindow.ChapterList.LastSelected)
		if tmpItem2~=nil then
			tmpItem2:SetBackColor(nil)
		end
		tmpIndex=tmpIndex+1
	end
	if tmpIndex==0 then
		tmpIndex=authorWindow.ChapterList:GetItemCount()+1
		authorWindow.ChapterList:AddItem(tmpItem)
	else
		for index=tmpIndex, authorWindow.ChapterList:GetItemCount() do
			local item=authorWindow.ChapterList:GetItem(index)
			item.Index=item.Index+1
			authorStory.Chapters[item.ID].DisplayOrder=index+1
		end
		authorWindow.ChapterList:InsertItem(tmpIndex,tmpItem)
	end
	authorStory.Chapters[newID].DisplayOrder=tmpIndex
	tmpItem.Index=tmpIndex
	tmpItem.MouseDoubleClick=function(sender,args)
		authorWindow.ChapterList:SetSelectedIndex(sender.Index)
		authorWindow.ChapterEditButton.Click()
	end
	authorWindow.ChapterList:SetSelectedIndex(tmpIndex)
	authorWindow.SetChangedState(true)
	authorWindow.ChapterEditButton.Click()
end

authorWindow.ChapterDeleteButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterDeleteButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterDeleteButton:SetSize(120,20)
authorWindow.ChapterDeleteButton:SetPosition(authorWindow.ChapterUpButton:GetLeft(),authorWindow.ChapterCopyButton:GetTop()+authorWindow.ChapterUpButton:GetHeight()+5)
authorWindow.ChapterDeleteButton:SetFont(Settings.Font)
authorWindow.ChapterDeleteButton:SetText(Resource[language][11])
authorWindow.ChapterDeleteButton:SetEnabled(false)
authorWindow.ChapterDeleteButton.Click=function()
	authorWindow.MouseMask:SetMouseVisible(true)
	if NewActiveChapter~=nil and NewActiveChapter==authorWindow.ChapterList:GetSelectedItem().ID then
		confirmDelete=PopUpDialog(Resource[language][33],Resource[language][83],1,Resource[language][32],Resource[language][19],nil,false,authorChapterDeleteOK)
	else
		confirmDelete=PopUpDialog(Resource[language][33],Resource[language][82],1,Resource[language][32],Resource[language][19],nil,false,authorChapterDeleteOK)
	end
end
authorChapterDeleteOK=function(flag)
	authorWindow.MouseMask:SetMouseVisible(false)
	confirmDelete=nil
	if flag==1 then
		-- remove the chapter from authorStory
		local ID=authorWindow.ChapterList:GetSelectedItem().ID
		table.remove(authorStory.Chapters,ID)
		local removeIndex=authorWindow.ChapterList:GetSelectedIndex()
		authorWindow.ChapterList:RemoveItemAt(removeIndex)
		-- fix chapterlist .Index and .ID
		for k=1,authorWindow.ChapterList:GetItemCount() do
			local item=authorWindow.ChapterList:GetItem(k)
			item.Index=k
			if item.ID>ID then
				item.ID=item.ID-1
			end
		end
		-- fix the displayOrder and chapterID for any transitions if possible
		for index,chapter in pairs(authorStory.Chapters) do
			if chapter.DisplayOrder>removeIndex then chapter.DisplayOrder=chapter.DisplayOrder-1 end
			if chapter.SuccessNextChapter~=nil then
				if chapter.SuccessNextChapter==ID then
					chapter.SuccessNextChapter=nil
				else
					if chapter.SuccessNextChapter>ID then chapter.SuccessNextChapter=chapter.SuccessNextChapter-1 end
				end
			end
			if chapter.FailNextChapter~=nil then
				if chapter.FailNextChapter==ID then
					chapter.FailNextChapter=nil
				else
					if chapter.FailNextChapter>ID then chapter.FailNextChapter=chapter.FailNextChapter-1 end
				end
			end
			if chapter.Objectives~=nil then
				for k,v in ipairs(chapter.Objectives) do
					if v.NextChapter~=nil then
						if v.NextChapter==ID then
							v.NextChapter=nil
						elseif v.NextChapter>ID then
							v.NextChapter=v.NextChapter-1
						end
					end
				end
			end
		end
		-- fix the NewActiveChapter if it is not nil
		if NewActiveChapter~=nil then
			if NewActiveChapter==ID then
				-- just reset the story, there's no way to know the correct active chapter
				NewActiveChapter=nil
				-- reset all statuses and counts
				for index,chapter in pairs(authorStory.Chapters) do
					chapter.Status=nil
					for k,v in pairs(chapter.Objectives) do
						v.Count=nil
						v.Status=nil
					end
				end
			else
				if NewActiveChapter>ID then NewActiveChapter=NewActiveChapter-1 end
			end
		end
		authorWindow.ChapterList.LastSelected=nil
		if removeIndex<=authorWindow.ChapterList:GetItemCount() then
			authorWindow.ChapterList:SetSelectedIndex(removeIndex)
		else
			if authorWindow.ChapterList:GetItemCount()>0 then
				authorWindow.ChapterList:SetSelectedIndex(authorWindow.ChapterList:GetItemCount())
			end
		end
		authorLoadObjChapterList()
		authorWindow.SetChangedState(true)
	end
end
authorWindow.ChapterDownButton=Turbine.UI.Lotro.Button()
authorWindow.ChapterDownButton:SetParent(authorWindow.ChapterPanel)
authorWindow.ChapterDownButton:SetSize(120,20)
authorWindow.ChapterDownButton:SetPosition(authorWindow.ChapterUpButton:GetLeft(),authorWindow.ChapterDeleteButton:GetTop()+authorWindow.ChapterUpButton:GetHeight()+5)
authorWindow.ChapterDownButton:SetFont(Settings.Font)
authorWindow.ChapterDownButton:SetText(Resource[language][28])
authorWindow.ChapterDownButton:SetEnabled(false)
authorWindow.ChapterDownButton.Click=function(sender,args)
	-- swap this line's DisplayOrder with the one above it then reload the list
	swapChapterDisplay(authorWindow.ChapterList.LastSelected,authorWindow.ChapterList.LastSelected+1)
	authorLoadObjChapterList()
	authorWindow.SetChangedState(true)
end

authorWindow.Message=Turbine.UI.Label()
authorWindow.Message:SetParent(authorWindow)
authorWindow.Message:SetSize(authorWindow:GetWidth()-50,20)
authorWindow.Message:SetPosition(25,authorWindow:GetHeight()-25)
authorWindow.Message:SetFont(Settings.Font)
authorWindow.Message:SetForeColor(Turbine.UI.Color.Gray)

authorDisplayCurrentStory=function()
	local index=getStoryIndexFromID(authorWindow.currentStoryID)
	authorWindow.NewActiveChapter=StoryList[index].ActiveChapter
	authorWindow.SetChangedState(false)
	if authorStory.Name==nil then authorStory.Name="" end
	if authorStory.Author==nil then authorStory.Author=localPlayer:GetName() end
	if authorStory.Desc==nil then authorStory.Desc="" end
	if authorStory.DefaultImagePath==nil then authorStory.DefaultImagePath=storyPath end
	authorWindow.AuthorName:SetText(authorStory.Author)
	authorWindow.StoryName:SetText(authorStory.Name)
	authorWindow.StoryDesc:SetText(authorStory.Desc)
	authorWindow.DefaultImagePath:SetText(authorStory.DefaultImagePath)
	Settings.DefaultImagePath=authorStory.DefaultImagePath -- we retain Settings.DefaultImagePath because there are some generic controls like imageViewer that look for it
	if authorStory.Chapters==nil then
		authorStory.Chapters={}
	end
	authorPopulateChapterList()
end
authorPopulateChapterList=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	authorWindow.ChapterList:ClearItems()
	authorWindow.ChapterList.OldIndex=-1
	tmpList={}
	for k,v in ipairs(authorStory.Chapters) do
		-- add chapters to temp list so we can order them by displayOrder
		table.insert(tmpList,{["ID"]=k,["DisplayOrder"]=v.DisplayOrder,["Name"]=v.Name})
	end
	-- now sort by displayOrder
	table.sort(tmpList, function(arg1,arg2) if arg1.DisplayOrder<arg2.DisplayOrder then return true end end)
	-- populate table
	for k,v in ipairs(tmpList) do
		local tmpItem=Turbine.UI.Label()
		tmpItem.ID=v.ID
		tmpItem:SetParent(authorWindow.ChapterList)
		tmpItem:SetSize(authorWindow.ChapterList:GetWidth(),controlHeight)
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetForeColor(Settings.FontColor)
		tmpItem:SetText(v.Name)
		tmpItem.Index=k
		tmpItem.MouseDoubleClick=function(sender,args)
			authorWindow.ChapterList:SetSelectedIndex(sender.Index)
			authorWindow.ChapterEditButton.Click()
		end
		authorWindow.ChapterList:AddItem(tmpItem)
	end
	-- disable the buttons that require a "current" selection
	authorWindow.ChapterUpButton:SetEnabled(false)
	authorWindow.ChapterNewButton:SetEnabled(true)
	authorWindow.ChapterEditButton:SetEnabled(false)
	authorWindow.ChapterCopyButton:SetEnabled(false)
	authorWindow.ChapterDeleteButton:SetEnabled(false)
	authorWindow.ChapterDownButton:SetEnabled(false)
	authorWindow.SetChangedState(false)
	authorLoadObjChapterList()
	authorWindow.MouseMask:SetMouseVisible(false)
	authorWindow.Message:SetText(Resource[language][24])
end
swapChapterDisplay=function(index1,index2)
	-- Do NOT use locals for swapSource and swapDest as they are used by the swapTransitions callback function (they are cleaned up there)
	swapSource=authorWindow.ChapterList:GetItem(index1).ID
	swapDest=authorWindow.ChapterList:GetItem(index2).ID
	tmpOrder=authorStory.Chapters[swapSource].DisplayOrder
	authorStory.Chapters[swapSource].DisplayOrder=authorStory.Chapters[swapDest].DisplayOrder
	authorStory.Chapters[swapDest].DisplayOrder=tmpOrder
	authorPopulateChapterList()
	authorWindow.ChapterList:SetSelectedIndex(index2)
	-- transistion adjustment seems to cause more grief than it solves.
end
swapTransitions=function(flag)
	authorWindow.MouseMask:SetMouseVisible(false)
	if flag==1 then
		-- any transition that pointed to the source should now go to the destination
		-- any transition that pointed to the destination should now go to the source
		for index,chapter in pairs(authorStory.Chapters) do
			if chapter.SuccessNextChapter~=nil then
				if chapter.SuccessNextChapter==swapSource then
					chapter.SuccessNextChapter=swapDest
				elseif chapter.SuccessNextChapter==swapDest then
					chapter.SuccessNextChapter=swapSource
				end
			end
			if chapter.FailNextChapter~=nil then
				if chapter.FailNextChapter==swapSource then
					chapter.FailNextChapter=swapDest
				elseif chapter.FailNextChapter==swapDest then
					chapter.FailNextChapter=swapSource
				end
			end
			for k,v in pairs(chapter.Objectives) do
				if v.NextChapter==swapSource then
					v.NextChapter=swapDest
				elseif v.NextChapter==swapDest then
					v.NextChapter=swapSource
				end
			end
		end
	end
	swapSource=nil
	swapDest=nil
end

authorWindow.SetChangedState=function(newState)
	authorWindow.StoryChanged=newState
	authorWindow.ResetButton:SetEnabled(newState)
	authorWindow.SaveButton:SetEnabled(newState)
	authorWindow.CreateNewButton:SetEnabled(not newState)
	authorWindow.EditExistingButton:SetEnabled(not newState)
end
authorWindow.MouseMask=Turbine.UI.Control()
authorWindow.MouseMask:SetParent(authorWindow)
authorWindow.MouseMask:SetMouseVisible(false)
authorWindow.MouseMask:SetZOrder(2)
authorWindow.MouseMask:SetSize(authorWindow:GetSize())

-- set default state
authorWindow.MainTab.MouseClick()
authorWindow.SetChangedState(false)

authorWindow.RefreshLayout=function()
	local minButtonWidth=140
	local minWindowWidth=885
	local minTabWidth=100
	local minLabelWidth=120
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local minLangWidth=120

	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	fontMetric:SetFont(buttonFont)

	local tmpWidth=fontMetric:GetTextWidth(Resource[language][8])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][14])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][132])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][21])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][16])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][7])+20
	if tmpWidth>minButtonWidth then minButtonWidth=tmpWidth end

	fontMetric:SetFont(Settings.Font)
	tmpWidth=fontMetric:GetTextWidth(Resource[language][22])+20
	if tmpWidth>minTabWidth then minTabWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][23])+20
	if tmpWidth>minTabWidth then minTabWidth=tmpWidth end

	tmpWidth=fontMetric:GetTextWidth(Resource[language][12]..":")+20
	if tmpWidth>minLabelWidth then minLabelWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][13]..":")+20
	if tmpWidth>minLabelWidth then minLabelWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][61]..":")+20
	if tmpWidth>minLabelWidth then minLabelWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][15]..":")+20
	if tmpWidth>minLabelWidth then minLabelWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][201]..":")+20
	if tmpWidth>minLabelWidth then minLabelWidth=tmpWidth end

	tmpWidth=fontMetric:GetTextWidth(Resource[language][62])+20
	if tmpWidth>minLangWidth then minLangWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][63])+20
	if tmpWidth>minLangWidth then minLangWidth=tmpWidth end
	tmpWidth=fontMetric:GetTextWidth(Resource[language][64])+20
	if tmpWidth>minLangWidth then minLangWidth=tmpWidth end

	if minButtonWidth>140 then
		minWindowWidth=885+6*(minButtonWidth-140)
	end
	if minWindowWidth>displayWidth then
		minWindowWidth=displayWidth
	end
	if minWindowWidth>authorWindow:GetWidth() then authorWindow:SetWidth(minWindowWidth) end -- will trigger a resize of container elements if needed
	authorWindow:SetMinimumWidth(minWindowWidth)

	authorWindow.ControlPanel:SetWidth(authorWindow:GetWidth())

	authorWindow.CreateNewButton:SetWidth(minButtonWidth)
	authorWindow.CreateNewButton:SetFont(buttonFont)
	authorWindow.CreateNewButton:SetText(Resource[language][8])
	authorWindow.EditExistingButton:SetLeft(authorWindow.CreateNewButton:GetLeft()+authorWindow.CreateNewButton:GetWidth()+5)
	authorWindow.EditExistingButton:SetWidth(minButtonWidth)
	authorWindow.EditExistingButton:SetFont(buttonFont)
	authorWindow.EditExistingButton:SetText(Resource[language][14])
	authorWindow.StoryboardButton:SetWidth(minButtonWidth)
	authorWindow.StoryboardButton:SetLeft(authorWindow.ControlPanel:GetWidth()-authorWindow.StoryboardButton:GetWidth()*4-25)
	authorWindow.StoryboardButton:SetFont(buttonFont)
	authorWindow.StoryboardButton:SetText(Resource[language][132])
	authorWindow.ResetButton:SetWidth(minButtonWidth)
	authorWindow.ResetButton:SetLeft(authorWindow.ControlPanel:GetWidth()-authorWindow.ResetButton:GetWidth()*3-20)
	authorWindow.ResetButton:SetFont(buttonFont)
	authorWindow.ResetButton:SetText(Resource[language][21])
	authorWindow.SaveButton:SetWidth(minButtonWidth)
	authorWindow.SaveButton:SetLeft(authorWindow.ControlPanel:GetWidth()-authorWindow.SaveButton:GetWidth()*2-15)
	authorWindow.SaveButton:SetFont(buttonFont)
	authorWindow.SaveButton:SetText(Resource[language][16])
	authorWindow.MenuButton:SetWidth(minButtonWidth)
	authorWindow.MenuButton:SetLeft(authorWindow.ControlPanel:GetWidth()-authorWindow.MenuButton:GetWidth()-10)
	authorWindow.MenuButton:SetFont(buttonFont)
	authorWindow.MenuButton:SetText(Resource[language][7])
	authorWindow.MainTab:SetSize(minTabWidth,controlHeight)
	authorWindow.MainTab:SetFont(Settings.Font)
	authorWindow.MainTab:SetText(Resource[language][22])
	authorWindow.MainTab.Underscore:SetWidth(fontMetric:GetTextWidth(authorWindow.MainTab:GetText()))
	authorWindow.MainTab.Underscore:SetTop(controlHeight-1)
	authorWindow.ChapterTab:SetSize(minTabWidth,controlHeight)
	authorWindow.ChapterTab:SetLeft(authorWindow.MainTab:GetLeft()+authorWindow.MainTab:GetWidth()+5)
	authorWindow.ChapterTab:SetFont(Settings.Font)
	authorWindow.ChapterTab:SetText(Resource[language][23])
	authorWindow.ChapterTab.Underscore:SetWidth(fontMetric:GetTextWidth(authorWindow.ChapterTab:GetText()))
	authorWindow.ChapterTab.Underscore:SetTop(controlHeight-1)

	authorWindow.MainPanel:SetTop(authorWindow.MainTab:GetTop()+authorWindow.MainTab:GetHeight()+1)
	authorWindow.MainPanel:SetSize(authorWindow:GetWidth(),authorWindow:GetHeight()-25-authorWindow.MainPanel:GetTop()-controlHeight)
	authorWindow.ChapterPanel:SetSize(authorWindow.MainPanel:GetSize())
	authorWindow.ChapterPanel:SetTop(authorWindow.MainPanel:GetTop())
	
	authorWindow.AuthorNameCaption:SetSize(minLabelWidth,controlHeight)
	authorWindow.AuthorNameCaption:SetFont(Settings.Font)
	authorWindow.AuthorNameCaption:SetText(Resource[language][12]..":")
	authorWindow.AuthorName:SetPosition(authorWindow.AuthorNameCaption:GetLeft()+authorWindow.AuthorNameCaption:GetWidth()+5,authorWindow.AuthorNameCaption:GetTop())
	authorWindow.AuthorName:SetSize(authorWindow.MainPanel:GetWidth()-authorWindow.AuthorName:GetLeft()-20,controlHeight)
	authorWindow.AuthorName:SetFont(Settings.Font)
	authorWindow.AuthorName:SetText(authorWindow.AuthorName:GetText())
	authorWindow.StoryNameCaption:SetSize(minLabelWidth,controlHeight)
	authorWindow.StoryNameCaption:SetTop(authorWindow.AuthorNameCaption:GetTop()+authorWindow.AuthorNameCaption:GetHeight()+5)
	authorWindow.StoryNameCaption:SetFont(Settings.Font)
	authorWindow.StoryNameCaption:SetText(Resource[language][13]..":")
	authorWindow.StoryName:SetSize(authorWindow.AuthorName:GetWidth(),controlHeight)
	authorWindow.StoryName:SetPosition(authorWindow.AuthorName:GetLeft(),authorWindow.StoryNameCaption:GetTop())
	authorWindow.StoryName:SetFont(Settings.Font)
	authorWindow.StoryName:SetText(authorWindow.StoryName:GetText())
	authorWindow.LanguageCaption:SetSize(minLabelWidth,controlHeight)
	authorWindow.LanguageCaption:SetTop(authorWindow.StoryNameCaption:GetTop()+authorWindow.StoryNameCaption:GetHeight()+5)
	authorWindow.LanguageCaption:SetFont(Settings.Font)
	authorWindow.LanguageCaption:SetText(Resource[language][61]..":")
	authorWindow.EN:SetSize(minLangWidth,controlHeight)
	authorWindow.EN:SetPosition(authorWindow.AuthorName:GetLeft(),authorWindow.LanguageCaption:GetTop())
	authorWindow.EN:SetFont(Settings.Font)
	authorWindow.EN:SetText(Resource[language][62])
	authorWindow.DE:SetSize(minLangWidth,controlHeight)
	authorWindow.DE:SetPosition(authorWindow.EN:GetLeft()+authorWindow.EN:GetWidth()+5,authorWindow.LanguageCaption:GetTop())
	authorWindow.DE:SetFont(Settings.Font)
	authorWindow.DE:SetText(Resource[language][63])
	authorWindow.FR:SetSize(minLangWidth,controlHeight)
	authorWindow.FR:SetPosition(authorWindow.DE:GetLeft()+authorWindow.DE:GetWidth()+5,authorWindow.LanguageCaption:GetTop())
	authorWindow.FR:SetFont(Settings.Font)
	authorWindow.FR:SetText(Resource[language][64])
	authorWindow.DefaultImagePathCaption:SetSize(minLabelWidth,controlHeight)
	authorWindow.DefaultImagePathCaption:SetTop(authorWindow.LanguageCaption:GetTop()+authorWindow.LanguageCaption:GetHeight()+5)
	authorWindow.DefaultImagePathCaption:SetFont(Settings.Font)
	authorWindow.DefaultImagePathCaption:SetText(Resource[language][201]..":")
	authorWindow.DefaultImagePath:SetSize(authorWindow.AuthorName:GetWidth(),controlHeight)
	authorWindow.DefaultImagePath:SetPosition(authorWindow.AuthorName:GetLeft(),authorWindow.DefaultImagePathCaption:GetTop())
	authorWindow.DefaultImagePath:SetFont(Settings.Font)
	authorWindow.DefaultImagePath:SetText(authorWindow.DefaultImagePath:GetText())
	authorWindow.StoryDescCaption:SetSize(minLabelWidth,controlHeight)
	authorWindow.StoryDescCaption:SetTop(authorWindow.DefaultImagePathCaption:GetTop()+authorWindow.DefaultImagePathCaption:GetHeight()+5)
	authorWindow.StoryDescCaption:SetFont(Settings.Font)
	authorWindow.StoryDescCaption:SetText(Resource[language][15]..":")
	authorWindow.StoryDescBack:SetPosition(authorWindow.AuthorName:GetLeft(),authorWindow.StoryDescCaption:GetTop())
	authorWindow.StoryDescBack:SetSize(authorWindow.MainPanel:GetWidth()-authorWindow.StoryName:GetLeft()-20,authorWindow.MainPanel:GetHeight()-authorWindow.StoryDescBack:GetTop())
	authorWindow.StoryDesc:SetSize(authorWindow.StoryDescBack:GetWidth()-2,authorWindow.StoryDescBack:GetHeight()-2)
	authorWindow.StoryDesc:SetFont(Settings.Font)
	authorWindow.StoryDesc:SetText(authorWindow.StoryDesc:GetText())
	authorWindow.StoryDescVScroll:SetHeight(authorWindow.StoryDescBack:GetHeight())
	authorWindow.StoryDescVScroll:SetPosition(authorWindow.StoryDescBack:GetLeft()+authorWindow.StoryDescBack:GetWidth(),authorWindow.StoryDescBack:GetTop())

	authorWindow.ChapterListBorder:SetSize(authorWindow.ChapterPanel:GetWidth()-35-120, authorWindow.ChapterPanel:GetHeight()) -- 25 for spaces, 120 for button width
	authorWindow.ChapterList:SetSize(authorWindow.ChapterListBorder:GetWidth()-2, authorWindow.ChapterListBorder:GetHeight()-2)
	authorWindow.ChapterListVScroll:SetHeight(authorWindow.ChapterListBorder:GetHeight())
	authorWindow.ChapterListVScroll:SetPosition(authorWindow.ChapterListBorder:GetLeft()+authorWindow.ChapterListBorder:GetWidth(),authorWindow.ChapterListBorder:GetTop())
	for i=1,authorWindow.ChapterList:GetItemCount() do
		local tmpItem=authorWindow.ChapterList:GetItem(i)
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetSize(authorWindow.ChapterList:GetWidth(),controlHeight)
	end
	authorWindow.ChapterUpButton:SetFont(buttonFont)
	authorWindow.ChapterUpButton:SetText(Resource[language][25])
	authorWindow.ChapterNewButton:SetFont(buttonFont)
	authorWindow.ChapterNewButton:SetText(Resource[language][26])
	authorWindow.ChapterEditButton:SetFont(buttonFont)
	authorWindow.ChapterEditButton:SetText(Resource[language][10])
	authorWindow.ChapterCopyButton:SetFont(buttonFont)
	authorWindow.ChapterCopyButton:SetText(Resource[language][27])
	authorWindow.ChapterDeleteButton:SetFont(buttonFont)
	authorWindow.ChapterDeleteButton:SetText(Resource[language][11])
	authorWindow.ChapterDownButton:SetFont(buttonFont)
	authorWindow.ChapterDownButton:SetText(Resource[language][28])
	authorWindow.ChapterUpButton:SetLeft(authorWindow.ChapterPanel:GetWidth()-130)
	authorWindow.ChapterNewButton:SetLeft(authorWindow.ChapterUpButton:GetLeft())
	authorWindow.ChapterEditButton:SetLeft(authorWindow.ChapterUpButton:GetLeft())
	authorWindow.ChapterCopyButton:SetLeft(authorWindow.ChapterUpButton:GetLeft())
	authorWindow.ChapterDeleteButton:SetLeft(authorWindow.ChapterUpButton:GetLeft())
	authorWindow.ChapterDownButton:SetLeft(authorWindow.ChapterUpButton:GetLeft())
	authorWindow.Message:SetTop(authorWindow:GetHeight()-5-controlHeight)
	authorWindow.Message:SetSize(authorWindow:GetWidth()-50,controlHeight)
	authorWindow.MouseMask:SetSize(authorWindow:GetSize())
end
authorWindow.RefreshLayout()
authorWindow.SizeChanged=function(sender,args)
	authorWindow.RefreshLayout()
end
authorWindow.RefreshColor=function()
	-- set colors for other authoring windows too!
	authorWindow.AuthorNameCaption:SetForeColor(Settings.LabelColor)
	authorWindow.AuthorName:SetForeColor(Settings.FontColor)
	authorWindow.StoryNameCaption:SetForeColor(Settings.LabelColor)
	authorWindow.StoryName:SetForeColor(Settings.FontColor)
	authorWindow.LanguageCaption:SetForeColor(Settings.LabelColor)
	authorWindow.EN:SetForeColor(Settings.FontColor)
	authorWindow.DE:SetForeColor(Settings.FontColor)
	authorWindow.FR:SetForeColor(Settings.FontColor)
	authorWindow.DefaultImagePathCaption:SetForeColor(Settings.LabelColor)
	authorWindow.DefaultImagePath:SetForeColor(Settings.FontColor)
	authorWindow.StoryDescCaption:SetForeColor(Settings.LabelColor)
	authorWindow.StoryDescBack:SetBackColor(Settings.TrimColor)
	authorWindow.StoryDesc:SetForeColor(Settings.FontColor)
	authorWindow.ChapterListBorder:SetBackColor(Settings.TrimColor)
	authorWindow.ChapterList:SetBackColor(Settings.BackColor)
	for i=1,authorWindow.ChapterList:GetItemCount() do
		local tmpItem=authorWindow.ChapterList:GetItem(i)
		tmpItem:SetForeColor(Settings.FontColor)
	end
	if authorWindow.MainTab.Selected then
		authorWindow.MainTab:SetForeColor(Settings.TabSelectedColor)
		authorWindow.ChapterTab:SetForeColor(Settings.TabUnSelectedColor)
	else
		authorWindow.MainTab:SetForeColor(Settings.TabUnSelectedColor)
		authorWindow.ChapterTab:SetForeColor(Settings.TabSelectedColor)
	end
	authorWindow.MainTab.Underscore:SetBackColor(Settings.TabSelectedColor)
	authorWindow.ChapterTab.Underscore:SetBackColor(Settings.TabSelectedColor)
end
authorWindow.RefreshColor()
authorWindow.StoryDeleted=function(ID)
	-- if story is selected in author, we can just click the "New" button
	if authorWindow.currentStoryID==ID then
		authorWindow.CreateNewButton.Click()
	end
end
loadMenu=function()
	Turbine.PluginManager.LoadPlugin("Anthology")
	authorWindow:SetVisible(false)
end
SaveSettings=function()
	-- save all of the generic settings that need to be updated whenever we switch back to the menu for any reason
	SaveSetting("Account",pluginName.."Settings","AuthorWindow","LastStory",authorWindow.currentStoryID)
	SaveSetting("Account",pluginName.."Settings","AuthorWindow","Width",authorWindow:GetWidth()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","AuthorWindow","Height",authorWindow:GetHeight()/displayHeight)
	SaveSetting("Account",pluginName.."Settings","AuthorWindow","Top",authorWindow:GetTop()/displayHeight)
	SaveSetting("Account",pluginName.."Settings","AuthorWindow","Left",authorWindow:GetLeft()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Left",iconWindow:GetLeft()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Top",iconWindow:GetTop()/displayHeight)
end
plugin.Unload=function()
	if authorWindow.SaveStory then
		PatchDataSave(Turbine.DataScope.Account,pluginName.."Story"..authorWindow.currentStoryID,authorStory)
	end
	-- save changes to story list
	PatchDataSave(Turbine.DataScope.Account,pluginName.."StoryList",StoryList)
end
authorWindow:SetVisible(true)
currentWindow=authorWindow
unloadMain=function()
	success,result=pcall(Turbine.PluginManager.UnloadScriptState,"Anthology");
end
SettingQueueCallback(unloadMain)
if authorWindow.currentStoryID~=nil and authorWindow.currentStoryID>0 then
	local index=getStoryIndexFromID(authorWindow.currentStoryID)
	if StoryList[index].ActiveChapter~=nil and Settings.Reloading==nil then
		authorWindow.MouseMask:SetMouseVisible(true)
		infoPopUp=PopUpDialog(Resource[language][37],Resource[language][38],4,Resource[language][32],nil,nil,false,authorWindow.CloseInfo)
	end
	authorDisplayCurrentStory()
end

updateChapterName=function(chapter,name)
	if authorStory~=nil and authorStory.Chapters[chapter]~=nil then
		-- update authorStory
		authorStory.Chapters[chapter].Name=name
		-- update authorWindow.ChapterList
		local index
		for k=1,authorWindow.ChapterList:GetItemCount() do
			local tmpItem=authorWindow.ChapterList:GetItem(k)
			if tmpItem.ID==chapter then
				tmpItem:SetText(name)
				index=k
				break
			end
		end
		authorWindow.SetChangedState(true)
		-- update Storyboard
		if Storyboard.Chapters[chapter]~=nil then
			if not Storyboard.Chapters[chapter].Name:HasFocus() then
				Storyboard.Chapters[chapter].Name:SetText(name)
			end
			Storyboard.Chapters[chapter]:SetWidth(Storyboard.Chapters[chapter].CalcWidth())
			Storyboard.Chapters[chapter].RefreshLayout()
			Storyboard.Chapters[chapter].RefreshTransitions()
		end
		-- update chapterMaint.ChapterName if it is showing this chapter
		if chapterMaint.ChapterID==chapter then
			-- only update name if it does not have focus
			if not chapterMaint.ChapterName:HasFocus() then
				chapterMaint.ChapterName:SetText(name)
			end
		end
		-- update chapterMaint goto lists
		chapterMaint.ObjectiveNextChapter.ListData:GetItem(index+2):SetText(name)
		chapterMaint.SuccessNextChapter.ListData:GetItem(index+2):SetText(name)
		if chapterMaint.SuccessNextChapter:GetSelectedIndex()==index+2 then
			chapterMaint.SuccessNextChapter.CurrentValue:SetText(name)
		end
		chapterMaint.FailNextChapter.ListData:GetItem(index+2):SetText(name)
		if chapterMaint.FailNextChapter:GetSelectedIndex()==index+2 then
			chapterMaint.FailNextChapter.CurrentValue:SetText(name)
		end
	end
end
updateObjectiveName=function(chapter,objective,name)
	if authorStory~=nil and authorStory.Chapters~=nil and authorStory.Chapters[chapter]~=nil and authorStory.Chapters[chapter].Objectives~=nil and authorStory.Chapters[chapter].Objectives[objective]~=nil then
		-- update authorStory
		authorStory.Chapters[chapter].Objectives[objective].Name=name
		local displayOrder=authorStory.Chapters[chapter].Objectives[objective].DisplayOrder
		-- update Storyboard.Chapters[chapter].Objectives[objective]
		if Storyboard.Chapters~=nil and Storyboard.Chapters[chapter]~=nil then
			if not Storyboard.Chapters[chapter].Objectives:GetItem(objective):HasFocus() then
				Storyboard.Chapters[chapter].Objectives:GetItem(objective):SetText(name)
			end
			Storyboard.Chapters[chapter]:SetWidth(Storyboard.Chapters[chapter].CalcWidth())
			Storyboard.Chapters[chapter].RefreshLayout()
			Storyboard.Chapters[chapter].RefreshTransitions()
		end
		if chapterMaint.ChapterID==chapter then
			if chapterMaint.ObjectiveList:GetSelectedIndex()==displayOrder and not chapterMaint.ObjectiveName:HasFocus() then
				-- update chapterMaint.ObjectiveName
				chapterMaint.ObjectiveName:SetText(name)
			end

			-- update chapterMaint.ObjectiveList:GetItem(displayOrder)
			chapterMaint.ObjectiveList:GetItem(displayOrder):SetText(name)
			-- update chapterMaint.SuccessList.ListData:GetItem(displayOrder)
			chapterMaint.SuccessList:GetItem(displayOrder):SetText(name)
			-- update chapterMaint.FailList.ListData:GetItem(displayOrder)
			chapterMaint.ObjectiveList:GetItem(displayOrder):SetText(name)
		end
	end
end