importPath=string.gsub(getfenv(1)._.Name,"%.IconWindow","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"

iconWindow=Turbine.UI.Window()
if Settings.useMiniIcon then
	iconWindow.UpImage=resourcePath.."mini_icon.tga"
	iconWindow.HoverImage=resourcePath.."mini_hover.tga"
	iconWindow.MoveImage=resourcePath.."mini_drag.tga"
	iconWindow.FlashImage=resourcePath.."mini_border.tga"
else
	iconWindow.UpImage=resourcePath.."icon_up.jpg"
	iconWindow.HoverImage=resourcePath.."icon_down.jpg"
	iconWindow.MoveImage=resourcePath.."icon_drag.jpg"
	iconWindow.FlashImage=resourcePath.."icon_border.tga"
end

restoreStorySelect=false
restoreChapterMaint=false
restoreStoryboard=false
restoreImageMaint=false
restoreImageViewer=false
currentVisible=true
chapterMaintVisible=false
selectVisible=false
storyboardVisible=false
imageMaintVisible=false
imageViewerVisible=false
hudVisible=true; -- assume hud is visible when loading plugins -- I hate this assumption, but Turbine has failed to provide a legitimate means of testing the hud state

iconWindow:SetBackground(iconWindow.UpImage);
iconWindow:SetSize(32,32);
iconWindow:SetOpacity(.3);
iconWindow:SetVisible(Settings.loadMinimized and Settings.showIcon);
function initIcon()
	if Settings.IconWindow==nil then
		Settings.IconWindow={}
	end
	local left=Settings.IconWindow.Left;
	if left==nil then
		left=0;
	else
		left=euroNormalize(left);
	end
	local top=Settings.IconWindow.Top;
	if top==nil then
		top=1-iconWindow:GetHeight()/displayHeight;
	else
		top=euroNormalize(top);
	end
	if left<0 then left=0 end
	if left*displayWidth+iconWindow:GetWidth()>displayWidth then
		left=1-iconWindow:GetWidth()/displayWidth
	end
	if top<0 then top=0 end
	if top*displayHeight+iconWindow:GetHeight()>displayHeight then top=1-iconWindow:GetHeight()/displayHeight end

	iconWindow:SetPosition(left*displayWidth, top*displayHeight);
end
initIcon();
iconWindow.MouseClick = function(sender,args)
	iconWindow:SetBackground(iconWindow.UpImage);
	if iconWindow.Moving then
		iconWindow.Moving=false;
		iconWindow.MoveX=-1;
	else
		iconWindow:SetVisible(false);
		currentWindow:SetVisible(true)
		-- restore the "modal" dialogs if needed
		if restoreStorySelect then
			storySelect:SetVisible(true)
		end
		if restoreChapterMaint then
			chapterMaint:SetVisible(true)
		end
		if restoreStoryboard then
			Storyboard:SetVisible(true)
		end
		if restoreImageMaint then
			imageMaint:SetVisible(true)
		end
		if restoreImageViewer then
			imageViewer:SetVisible(true)
		end
		if not restoreStorySelect and not restoreChapterMaint and not restoreImageMaint then
			-- need to set currentwindowmousemask
			currentWindow.MouseMask:SetMouseVisible(false);
		end
	end
end

iconWindow.MoveX=-1;
iconWindow.MoveY=0;
iconWindow.Moving=false;

iconWindow.MouseDown=function(sender,args)
	if iconWindow:IsControlKeyDown() then
		iconWindow:SetBackground(iconWindow.HoverImage);
		iconWindow.MoveX=args.X;
		iconWindow.MoveY=args.Y;
	end
end
iconWindow.MouseUp=function(sender,args)
	iconWindow:SetBackground(iconWindow.UpImage);
	iconWindow.MoveX=-1;
	iconWindow.MoveY=0;
end

iconWindow.MouseEnter=function(sender,args)
	iconWindow:SetOpacity(1);
end

iconWindow.MouseLeave=function(sender,args)
	iconWindow:SetOpacity(.3);
end

iconWindow.MouseMove=function(sender,args)
	if iconWindow.MoveX~=-1 and (args.X~=iconWindow.MoveX or args.Y~= iconWindow.MoveY) then
		iconWindow:SetBackground(iconWindow.MoveImage);
		iconWindow.Moving=true;
		local newLeft=iconWindow:GetLeft()-(iconWindow.MoveX-args.X)
		local newTop=iconWindow:GetTop()-(iconWindow.MoveY-args.Y)
		if newLeft<0 then newLeft=0 end;
		if newLeft>(Turbine.UI.Display.GetWidth()-iconWindow:GetWidth()) then newLeft=Turbine.UI.Display.GetWidth()-iconWindow:GetWidth() end;
		if newTop<0 then newTop=0 end;
		if newTop>(Turbine.UI.Display.GetHeight()-iconWindow:GetHeight()) then newTop=Turbine.UI.Display.GetHeight()-iconWindow:GetHeight() end;
		iconWindow:SetPosition(newLeft,newTop);
		if setupWindow~=nil and setupWindow:IsVisible() then
			setupWindow.iconLeft:SetText(newLeft);
			setupWindow.iconTop:SetText(newTop);
		end
	end
end

iconWindow.FlashBackground=Turbine.UI.Control();
iconWindow.FlashBackground:SetParent(iconWindow);
iconWindow.FlashBackground:SetMouseVisible(false);
iconWindow.FlashBackground:SetVisible(false);
iconWindow.FlashBackground:SetSize(32,32);
iconWindow.FlashBackground:SetBlendMode(Turbine.UI.BlendMode.Overlay);
iconWindow.FlashBackground:SetBackground(iconWindow.FlashImage);
iconWindow.FlashBackground:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
iconWindow.Flashing=false;
iconWindow.FlashCount=0;
iconWindow.Flash=function(sender,color)
	iconWindow:SetWantsUpdates(true);
	iconWindow.Flashing=true;
	iconWindow.FlashCount=0;
	iconWindow.FlashBackground:SetBackColor(color);
	iconWindow.FlashBackground:SetVisible(true);
	iconWindow.FlashState=1;
	iconWindow.FlashTimer=Turbine.Engine:GetGameTime()+.2;
	iconWindow:SetOpacity(1)
	iconWindow:SetVisible(true);
end
iconWindow.Update=function(sender,args)
	if iconWindow.Flashing then
		if Turbine.Engine:GetGameTime()>iconWindow.FlashTimer then
			if iconWindow.FlashState==0 then
				iconWindow.FlashBackground:SetVisible(true);
				iconWindow.FlashState=1;
				iconWindow.FlashTimer=Turbine.Engine:GetGameTime()+.2;
			else
				iconWindow.FlashBackground:SetVisible(false);
				iconWindow.FlashCount=iconWindow.FlashCount+1;
				if iconWindow.FlashCount>3 then
					iconWindow.Flashing=false;
					iconWindow:SetOpacity(.3);
					iconWindow:SetWantsUpdates(false);
					if inventoryWindow:IsVisible() or minimalWindow:IsVisible() then
						iconWindow:SetVisible(false);
					end
				else
					iconWindow.FlashState=0;
					iconWindow.FlashTimer=Turbine.Engine:GetGameTime()+.2;
				end
			end
		end
	else
		iconWindow.SetWantsUpdates(false); -- turn updates off... no need to waste machine cycles on this
	end
end
iconWindow.KeyDown=function(sender,args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		if currentWindow:IsVisible() then
			currentWindow:SetVisible(false);
			iconWindow:SetVisible(true)
			if storySelect~=nil then
				restoreStorySelect=(storySelect:IsVisible())
				storySelect:SetVisible(false)
			end
			if chapterMaint~=nil then
				restoreChapterMaint=(chapterMaint:IsVisible())
				chapterMaint:SetVisible(false);
			end
			if Storyboard~=nil then
				restoreStoryboard=(Storyboard:IsVisible())
				Storyboard:SetVisible(false)
			end
			if imageMaint~=nil then
				restoreImageMaint=(imageMaint:IsVisible())
				imageMaint:SetVisible(false)
			end
			if imageViewer~=nil then
				restoreImageViewer=(imageViewer:IsVisible())
				imageViewer:SetVisible(false)
			end
		end
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		hudVisible=not hudVisible;
		if hudVisible then
			currentWindow:SetVisible(currentVisible);
			if storySelect~=nil then
				storySelect:SetVisible(selectVisible);
			end
			if Storyboard~=nil then
				Storyboard:SetVisible(storyboardVisible)
			end
			if imageMaint~=nil then
				imageMaint:SetVisible(imageMaintVisible)
			end
			if imageViewer~=nil then
				imageViewer:SetVisible(imageViewerVisible)
			end
		else
			currentVisible=currentWindow:IsVisible();
			currentWindow:SetVisible(false);
			if storySelect~=nil then
				selectVisible=storySelect:IsVisible();
				storySelect:SetVisible(false);
			end
			if Storyboard~=nil then
				storyboardVisible=Storyboard:IsVisible()
				Storyboard:SetVisible(false)
			end
			if imageMaint~=nil then
				imageMaintVisible=imageMaint:IsVisible()
				imageMaint:SetVisible(false)
			end
			if imageViewer~=nil then
				imageViewerVisible=imageViewer:IsVisible()
				imageViewer:SetVisible(false)
			end
		end
	end
end
iconWindow:SetWantsKeyEvents(true);
iconWindow.Update=function()
	-- use the Update mechanism to set the commands so we know the prior instance unloaded first
	iconWindow.shellCmd=Turbine.ShellCommand();
	Turbine.Shell.AddCommand(pluginName,iconWindow.shellCmd);

	iconWindow.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == string.lower(pluginName)) then
			local pos1=string.find(args," ",0,true);
			local command;
			if pos1~=nil and pos1>0 then
				command=string.lower(string.sub(args,1,pos1-1));
			else
				command=string.lower(args);
			end
			if (command=="show") then
				if not currentWindow:IsVisible() then
					iconWindow.MouseClick()
				end
			elseif (command=="hide") then
				if currentWindow:IsVisible() then
					currentWindow:SetVisible(false);
					iconWindow:SetVisible(true)
					if storySelect~=nil then
						restoreStorySelect=(storySelect:IsVisible())
						storySelect:SetVisible(false)
					end
					if chapterMaint~=nil then
						restoreChapterMaint=(chapterMaint:IsVisible())
						chapterMaint:SetVisible(false);
					end
					if Storyboard~=nil then
						restoreStoryboard=(Storyboard:IsVisible())
						Storyboard:SetVisible(false)
					end
					if imageMaint~=nil then
						restoreImageMaint=(imageMaint:IsVisible())
						imageMaint:SetVisible(false)
					end
					if imageViewer~=nil then
						restoreImageViewer=(imageViewer:IsVisible())
						imageViewer:SetVisible(false)
					end
				end
			elseif (command=="toggle") then
				if currentWindow:IsVisible() then
					currentWindow:SetVisible(false);
					iconWindow:SetVisible(true)
					if storySelect~=nil then
						restoreStorySelect=(storySelect:IsVisible())
						storySelect:SetVisible(false)
					end
					if chapterMaint~=nil then
						restoreChapterMaint=(chapterMaint:IsVisible())
						chapterMaint:SetVisible(false);
					end
					if Storyboard~=nil then
						restoreStoryboard=(Storyboard:IsVisible())
						Storyboard:SetVisible(false)
					end
					if imageMaint~=nil then
						restoreImageMaint=(imageMaint:IsVisible())
						imageMaint:SetVisible(false)
					end
					if imageViewer~=nil then
						restoreImageViewer=(imageViewer:IsVisible())
						imageViewer:SetVisible(false)
					end
				else
					iconWindow.MouseClick()
				end
			elseif (command=="debug") then
				debugWindow:SetVisible(true);
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /"..pluginName.." show");
				Turbine.Shell.WriteLine("       Displays "..pluginName..".");
				Turbine.Shell.WriteLine("  /"..pluginName.." hide");
				Turbine.Shell.WriteLine("       Hides "..pluginName..".");
				Turbine.Shell.WriteLine("  /"..pluginName.." toggle");
				Turbine.Shell.WriteLine("       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).");
			end
		end
	end
	iconWindow.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /"..pluginName.." show\n       Displays "..pluginName..".\n  /"..pluginName.." hide\n       Hides "..pluginName..".\n  /"..pluginName.." toggle\n       Toggles "..pluginName.." (shows it if it was hidden, hides it if it was showing).");
	end
	iconWindow.shellCmd.GetShortHelp = function(sender, cmd)
		return(pluginName.." - usage: /"..pluginName.." show | hide | toggle");
	end
end
iconWindow:SetWantsUpdates(true);
UnloadPlugin=function()
	if currentWindow.Unload~=nil then
		currentWindow.Unload()
	end
end
plugin.Unload=function() UnloadPlugin() end
