importPath=string.gsub(getfenv(1)._.Name,"%.ImageMaint","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

imageMaint=Turbine.UI.Lotro.Window()
imageMaint:SetMinimumSize(600,400)

if Settings.ImageMaintWidth==nil then
	Settings.ImageMaintWidthWidth=imageMaint:GetMinimumWidth()/displayWidth
else
	Settings.ImageMaintWidthWidth=euroNormalize(Settings.ImageMaintWidthWidth)
end
if Settings.ImageMaintWidthHeight==nil then
	Settings.ImageMaintWidthHeight=imageMaint:GetMinimumHeight()/displayWidth
else
	Settings.ImageMaintWidthHeight=euroNormalize(Settings.ImageMaintWidthHeight)
end

imageMaint:SetSize(Settings.ImageMaintWidthWidth*displayWidth,Settings.ImageMaintWidthHeight*displayWidth)
imageMaint:SetPosition((displayWidth-imageMaint:GetWidth())/2,(displayHeight-imageMaint:GetHeight())/2)

imageMaint:SetZOrder(3) -- chapterMaint is ZOrder 2
imageMaint:SetText(Resource[language][190])
imageMaint.TargetControl=nil -- name of control we are managing
imageMaint:SetVisible(false)
imageMaint:SetResizable(true)
imageMaint.ShowMaint=function(targetControl)
	if Settings.DefaultImagePath==nil then Settings.DefaultImagePath="" end
	imageMaint.TargetControl=targetControl
	if targetControl~=nil then
		imageMaint:SetVisible(true)
		imageMaint.OrigSubfolder=targetControl.ImagePath
		if imageMaint.OrigSubfolder==nil then imageMaint.OrigSubfolder="" end
		imageMaint.OrigFileName=targetControl.FileName
		if imageMaint.OrigFileName==nil then imageMaint.OrigFileName="" end
		if imageMaint.OrigSubfolder==nil and imageMaint.OrigFileName=="" then
			imageMaint.ImageSubfolder:SetText(Settings.DefaultImagePath)
		else
			imageMaint.ImageSubfolder:SetText(imageMaint.OrigSubfolder)
		end
		imageMaint.ImageFileName:SetText(imageMaint.OrigFileName)
		imageMaint.ImageFileName.TextChanged()
	else
		-- shouldn't ever happen
		imageMaint.OrigSubfolder=""
		imageMaint.OrigFileName=""
	end
	imageMaint.Apply:SetEnabled(false)
end
imageMaint.Closing=function(sender,args)
	if imageMaint.OrigSubfolder~=imageMaint.ImageSubfolder:GetText() or imageMaint.OrigFileName~=imageMaint.ImageFileName:GetText() then
		args.Cancel=true
		imageMaint.MouseMask:SetMouseVisible(true)
		confirmClose=PopUpDialog(Resource[language][35],Resource[language][36],1,Resource[language][32],Resource[language][19],nil,false,imageMaint.ConfirmClose)		
		confirmClose:SetZOrder(imageMaint:GetZOrder()+1)
	end
end
imageMaint.Closed=function()
	chapterMaint.MouseMask:SetMouseVisible(false)
end
imageMaint.ConfirmClose=function(flag)
	imageMaint.MouseMask:SetMouseVisible(false)
	confirmClose=nil
	if flag==1 then
		imageMaint:SetVisible(false)
		chapterMaint.MouseMask:SetMouseVisible(false)
	end
end

imageMaint.Changed=false
imageMaint.ImageNote=Turbine.UI.Label()
imageMaint.ImageNote:SetParent(imageMaint)
imageMaint.ImageNote:SetPosition(10,40)

imageMaint.ImageSubfolderCaption=Turbine.UI.Label()
imageMaint.ImageSubfolderCaption:SetParent(imageMaint)
imageMaint.ImageSubfolderCaption:SetLeft(10)
imageMaint.ImageSubfolder=Turbine.UI.Lotro.TextBox()
imageMaint.ImageSubfolder:SetParent(imageMaint)
imageMaint.ImageSubfolder:SetMultiline(false)
imageMaint.ImageSubfolder.KeyDown=function(sender,args)
	if args.Action==75 then
		imageMaint.ImageFileName.TextChanged()
	end
end
imageMaint.ImageSubfolder.TextChanged=function()
	imageMaint.ImageFileName.TextChanged()
end

imageMaint.ImageFileNameCaption=Turbine.UI.Label()
imageMaint.ImageFileNameCaption:SetParent(imageMaint)
imageMaint.ImageFileNameCaption:SetLeft(10)
imageMaint.ImageFileName=Turbine.UI.Lotro.TextBox()
imageMaint.ImageFileName:SetParent(imageMaint)
imageMaint.ImageFileName:SetMultiline(false)
imageMaint.ImageFileName.KeyDown=function(sender,args)
	if args.Action==75 then
		imageMaint.ImageFileName.TextChanged()
	end
end
imageMaint.ImageFileName.TextChanged=function()
	local path=imageMaint.ImageSubfolder:GetText()
	if path~="" then path=path.."/" end
	local name=imageMaint.ImageFileName:GetText()
	if path=="" and tonumber(name)~=nil and tonumber(name)>0 then
		path=tonumber(name)
	else
		path=path..name
	end
	-- try to load image
	imageMaint.ImagePreview:SetSize(1,1)
	success,result=pcall(Turbine.UI.Control.SetBackground,imageMaint.ImagePreview,path)
	if success then
		imageMaint.ImagePreview:SetVisible(true) -- control has to be set to visible for the stretchmode to function correctly
		imageMaint.ImagePreview:SetStretchMode(2) -- set control to image size
		imageMaint.ImagePreview.ImageWidth,imageMaint.ImagePreview.ImageHeight=imageMaint.ImagePreview:GetSize()
		imageMaint.ImagePreview.Aspect=imageMaint.ImagePreview.ImageWidth/imageMaint.ImagePreview.ImageHeight
		imageMaint.ResizeImage()
		imageMaint.ImagePreviewBack:SetVisible(false)
	else
		imageMaint.ImagePreview:SetVisible(false)
		imageMaint.ImagePreviewBack:SetVisible(true)
	end
	imageMaint.Apply:SetEnabled(imageMaint.OrigSubfolder~=imageMaint.ImageSubfolder:GetText() or imageMaint.OrigFileName~=imageMaint.ImageFileName:GetText())
end

imageMaint.ImagePreviewCaption=Turbine.UI.Label()
imageMaint.ImagePreviewCaption:SetParent(imageMaint)
imageMaint.ImagePreviewCaption:SetLeft(10)
imageMaint.ImagePreviewBack=Turbine.UI.Label()
imageMaint.ImagePreviewBack:SetParent(imageMaint)
imageMaint.ImagePreviewBack:SetLeft(10)
imageMaint.ImagePreviewBack:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)

imageMaint.ImagePreview=Turbine.UI.Control()
imageMaint.ImagePreview:SetParent(imageMaint)
imageMaint.ImagePreview:SetStretchMode(0)
imageMaint.ImagePreview:SetVisible(false)
imageMaint.ImagePreview.Aspect=1
imageMaint.ImagePreview.ImageWidth=0
imageMaint.ImagePreview.ImageHeight=0
imageMaint.ImagePreview:SetMouseVisible(false)
imageMaint.ImagePreview:SetVisible(false)
imageMaint.ImagePreview:SetBlendMode(Turbine.UI.BlendMode.Overlay)
imageMaint.Apply=Turbine.UI.Lotro.Button()
imageMaint.Apply:SetParent(imageMaint)
imageMaint.Apply.Click=function()
	if imageMaint.TargetControl~=nil then
		imageMaint.TargetControl.ImagePath=imageMaint.ImageSubfolder:GetText()
		local tmpName=imageMaint.ImageFileName:GetText()
		if imageMaint.TargetControl.ImagePath=="" and tonumber(tmpName)~=nil and tonumber(tmpName)>0 then
			imageMaint.TargetControl.FileName=tonumber(tmpName)
		else
			imageMaint.TargetControl.FileName=tmpName
		end
		chapterMaint.SetImage(imageMaint.TargetControl)
		imageMaint.OrigSubfolder=imageMaint.ImageSubfolder:GetText()
		imageMaint.OrigFileName=imageMaint.ImageFileName:GetText()
		imageMaint.Apply:SetEnabled(false)
		local content=authorStory.Chapters[chapterMaint.ChapterID].Content[imageMaint.TargetControl:GetParent().Index]
		content.Path=imageMaint.OrigSubfolder
		content.FileName=imageMaint.OrigFileName
		authorWindow.SetChangedState(true)
	end
end
imageMaint.MouseMask=Turbine.UI.Control()
imageMaint.MouseMask:SetParent(imageMaint)
imageMaint.MouseMask:SetMouseVisible(false)
imageMaint.MouseMask:SetSize(imageMaint:GetSize())

imageMaint.SizeChanged=function()
	imageMaint.RefreshLayout()
	imageMaint.MouseMask:SetSize(imageMaint:GetSize())
end
imageMaint.ResizeImage=function()
	local tmpAspect=imageMaint.ImagePreviewBack:GetWidth()/imageMaint.ImagePreviewBack:GetHeight()
	local maxWidth,maxHeight
	if tmpAspect>imageMaint.ImagePreview.Aspect then
		-- if container aspect > image aspect then width is dominant factor
		maxWidth=math.floor(imageMaint.ImagePreviewBack:GetHeight()*imageMaint.ImagePreview.Aspect)
		maxHeight=imageMaint.ImagePreviewBack:GetHeight()
	else
		maxWidth=imageMaint.ImagePreviewBack:GetWidth()
		maxHeight=math.floor(imageMaint.ImagePreviewBack:GetWidth()/imageMaint.ImagePreview.Aspect)
	end
	if maxWidth>imageMaint.ImagePreview.ImageWidth then maxWidth=imageMaint.ImagePreview.ImageWidth end
	if maxHeight>imageMaint.ImagePreview.ImageHeight then maxHeight=imageMaint.ImagePreview.ImageHeight end

	if imageMaint.ImagePreview.ImageWidth<=maxWidth and imageMaint.ImagePreview.ImageHeight<=maxHeight then
		imageMaint.ImagePreview:SetStretchMode(0)
		imageMaint.ImagePreview:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	else
		imageMaint.ImagePreview:SetStretchMode(1)
		imageMaint.ImagePreview:SetBlendMode(nil)
	end
	imageMaint.ImagePreview:SetSize(maxWidth,maxHeight)
	imageMaint.ImagePreview:SetPosition(imageMaint.ImagePreviewBack:GetLeft()+(imageMaint.ImagePreviewBack:GetWidth()-maxWidth)/2,imageMaint.ImagePreviewBack:GetTop()+(imageMaint.ImagePreviewBack:GetHeight()-maxHeight)/2)
end

imageMaint.RefreshLayout=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	imageMaint.ImageNote:SetSize(imageMaint:GetWidth()-20,controlHeight*2)
	imageMaint.ImageNote:SetFont(Settings.Font)
	imageMaint.ImageNote:SetText(Resource[language][184])

	fontMetric:SetFont(Settings.Font)
	local minWidth=fontMetric:GetTextWidth(Resource[language][185])+20
	local tmp=fontMetric:GetTextWidth(Resource[language][186])+20
	if tmp>minWidth then minWidth=tmp end
	imageMaint.ImageSubfolderCaption:SetTop(imageMaint.ImageNote:GetTop()+imageMaint.ImageNote:GetHeight()+5)
	imageMaint.ImageSubfolderCaption:SetSize(minWidth,controlHeight)
	imageMaint.ImageSubfolderCaption:SetFont(Settings.Font)
	imageMaint.ImageSubfolderCaption:SetText(Resource[language][185])
	imageMaint.ImageSubfolder:SetPosition(imageMaint.ImageSubfolderCaption:GetLeft()+imageMaint.ImageSubfolderCaption:GetWidth()+5,imageMaint.ImageSubfolderCaption:GetTop())
	imageMaint.ImageSubfolder:SetSize(imageMaint:GetWidth()-20-imageMaint.ImageSubfolder:GetLeft(),controlHeight)
	imageMaint.ImageSubfolder:SetFont(Settings.Font)
	imageMaint.ImageSubfolder:SetText(imageMaint.ImageSubfolder:GetText())

	imageMaint.ImageFileNameCaption:SetTop(imageMaint.ImageSubfolder:GetTop()+imageMaint.ImageSubfolder:GetHeight()+5)
	imageMaint.ImageFileNameCaption:SetSize(minWidth,controlHeight)
	imageMaint.ImageFileNameCaption:SetFont(Settings.Font)
	imageMaint.ImageFileNameCaption:SetText(Resource[language][186])
	imageMaint.ImageFileName:SetPosition(imageMaint.ImageSubfolder:GetLeft(),imageMaint.ImageFileNameCaption:GetTop())
	imageMaint.ImageFileName:SetSize(imageMaint.ImageSubfolder:GetWidth(),controlHeight)
	imageMaint.ImageFileName:SetFont(Settings.Font)
	imageMaint.ImageFileName:SetText(imageMaint.ImageFileName:GetText())

	imageMaint.ImagePreviewCaption:SetPosition(10,imageMaint.ImageFileNameCaption:GetTop()+imageMaint.ImageFileNameCaption:GetHeight()+5)
	imageMaint.ImagePreviewCaption:SetSize(imageMaint:GetWidth()-20,controlHeight)
	imageMaint.ImagePreviewCaption:SetFont(Settings.Font)
	imageMaint.ImagePreviewCaption:SetText(Resource[language][187])

	imageMaint.ImagePreviewBack:SetPosition(10,imageMaint.ImagePreviewCaption:GetTop()+imageMaint.ImagePreviewCaption:GetHeight()+5)
	imageMaint.ImagePreviewBack:SetSize(imageMaint:GetWidth()-20,imageMaint:GetHeight()-45-imageMaint.ImagePreviewBack:GetTop())
	imageMaint.ImagePreviewBack:SetFont(Settings.Font)
	imageMaint.ImagePreviewBack:SetText(Resource[language][188])

	fontMetric:SetFont(buttonFont)
	imageMaint.Apply:SetWidth(fontMetric:GetTextWidth(Resource[language][191])+20)
	imageMaint.Apply:SetFont(buttonFont)
	imageMaint.Apply:SetText(Resource[language][191])
	imageMaint.Apply:SetPosition((imageMaint:GetWidth()-imageMaint.Apply:GetWidth())/2,imageMaint:GetHeight()-40)
	imageMaint.ResizeImage()
end
imageMaint.RefreshLayout()
imageMaint.RefreshColor=function()
	imageMaint.ImageNote:SetForeColor(Settings.LabelColor)
	imageMaint.ImageSubfolderCaption:SetForeColor(Settings.LabelColor)
	imageMaint.ImageSubfolder:SetForeColor(Settings.FontColor)
	imageMaint.ImageFileNameCaption:SetForeColor(Settings.LabelColor)
	imageMaint.ImageFileName:SetForeColor(Settings.FontColor)
	imageMaint.ImagePreviewBack:SetForeColor(Settings.LabelColor)
	imageMaint.ImagePreviewCaption:SetForeColor(Settings.LabelColor)
end
imageMaint.RefreshColor()