importPath=string.gsub(getfenv(1)._.Name,"%.ImageViewer","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

if Settings==nil then Settings={} end
if Settings.TrimColor==nil then Settings.TrimColor=Turbine.UI.Color(.15,.15,.25) end

imageViewer=Turbine.UI.Window()
imageViewer:SetSize(displayWidth,displayHeight)
imageViewer:SetBackColor(Settings.TrimColor)

imageViewer:SetPosition(0,0)

imageViewer:SetZOrder(3) -- chapterMaint is ZOrder 2

imageViewer.ViewPort=Turbine.UI.ListBox()
imageViewer.ViewPort:SetParent(imageViewer)
imageViewer.ViewPort:SetPosition(1,1)
imageViewer.ViewPort:SetSize(displayWidth,displayHeight)
imageViewer.ViewPort:SetBackColor(Turbine.UI.Color.Black)

imageViewer.Canvas=Turbine.UI.Control()
imageViewer.Canvas:SetParent(imageViewer.ViewPort)
imageViewer.ViewPort:AddItem(imageViewer.Canvas)

imageViewer.Image=Turbine.UI.Control()
imageViewer.Image:SetParent(imageViewer.Canvas)
imageViewer.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
imageViewer.Canvas:SetMouseVisible(false)
imageViewer.Image:SetMouseVisible(false)

imageViewer.ViewPortVScroll=Turbine.UI.Lotro.ScrollBar()
imageViewer.ViewPortVScroll:SetParent(imageViewer)
imageViewer.ViewPortVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
imageViewer.ViewPortVScroll:SetSize(10,displayHeight-10)
imageViewer.ViewPortVScroll:SetPosition(displayWidth-10,10)
imageViewer.ViewPort:SetVerticalScrollBar(imageViewer.ViewPortVScroll)

imageViewer.ViewPortHScroll=Turbine.UI.Lotro.ScrollBar()
imageViewer.ViewPortHScroll:SetParent(imageViewer)
imageViewer.ViewPortHScroll:SetOrientation(Turbine.UI.Orientation.Horizontal)
imageViewer.ViewPortHScroll:SetSize(displayWidth-10,10)
imageViewer.ViewPortHScroll:SetPosition(0,displayHeight-10)
imageViewer.ViewPort:SetHorizontalScrollBar(imageViewer.ViewPortHScroll)

imageViewer.ShowImage=function(imagePath,imageFileName)
	local path=imagePath
	if imagePath==nil then imagePath="" end
	if imageFileName==nil then imageFileName="" end
	if imagePath=="" and tonumber(imageFileName)~=nil and tonumber(imageFileName)>0 then
		imagePath=tonumber(imageFileName)
	else
		if string.sub(imagePath,-1)~="/" then
			imagePath=imagePath.."/"
		end
		imagePath=imagePath..imageFileName
	end
	-- load the image into a temp control to get its size
	local tmpImage=Turbine.UI.Control()
	pcall(Turbine.UI.Control.SetBackground,tmpImage,imagePath)
	tmpImage:SetStretchMode(2)
	-- then size the canvas to the image size and load the image
	imageViewer.Width,imageViewer.Height=tmpImage:GetSize()
	imageViewer.Image:SetSize(imageViewer.Width,imageViewer.Height)
	pcall(Turbine.UI.Control.SetBackground,imageViewer.Image,imagePath)
	tmpImage=nil
	if imageViewer.Width< displayWidth-1 then
		-- no scrollbars, center viewer
		imageViewer.Canvas:SetWidth(imageViewer.Width)
		imageViewer.ViewPort:SetWidth(imageViewer.Width)
		imageViewer:SetWidth(imageViewer.Width+2)
		imageViewer:SetLeft((displayWidth-imageViewer.Width)/2-1)
		imageViewer.ViewPort:SetLeft(1)
	elseif imageViewer.Width<=displayWidth then
		-- no scrollbars, center viewer
		imageViewer.Canvas:SetWidth(imageViewer.Width)
		imageViewer.ViewPort:SetWidth(imageViewer.Width)
		imageViewer:SetWidth(imageViewer.Width)
		imageViewer:SetLeft((displayWidth-imageViewer.Width)/2)
		imageViewer.ViewPort:SetLeft(0)
	else
		-- need scrollbars, set canvas 10 pixels wider
		imageViewer.ViewPort:SetWidth(displayWidth)
		imageViewer.Canvas:SetWidth(imageViewer.Width+10)
		imageViewer:SetWidth(displayWidth)
		imageViewer:SetLeft(0)
		imageViewer.ViewPort:SetLeft(0)
	end
	imageViewer.CloseButton:SetLeft(imageViewer:GetWidth()-16)
	if imageViewer.Height<= displayHeight-1 then
		-- no scrollbars, center image
		imageViewer.ViewPort:SetHeight(imageViewer.Height)
		imageViewer.Canvas:SetHeight(imageViewer.Height)
		imageViewer:SetHeight(imageViewer.Height+2)
		imageViewer:SetTop((displayHeight-imageViewer.Height)/2-1)
		imageViewer.ViewPort:SetTop(1)
	elseif imageViewer.Height<= displayHeight then
		-- no scrollbars, center image
		imageViewer.ViewPort:SetHeight(imageViewer.Height)
		imageViewer.Canvas:SetHeight(imageViewer.Height)
		imageViewer:SetHeight(imageViewer.Height)
		imageViewer:SetTop((displayHeight-imageViewer.Height)/2)
		imageViewer.ViewPort:SetTop(0)
	else
		-- need scrollbars, set canvas 10 pixels taller
		imageViewer.ViewPort:SetHeight(displayHeight)
		imageViewer.Canvas:SetHeight(imageViewer.Height+10)
		imageViewer:SetHeight(displayHeight)
		imageViewer:SetTop(0)
		imageViewer.ViewPort:SetTop(0)
	end
	imageViewer:SetVisible(true)
end
imageViewer.CloseButton=Turbine.UI.Control()
imageViewer.CloseButton:SetParent(imageViewer)
imageViewer.CloseButton:SetZOrder(1)
imageViewer.CloseButton:SetSize(16,16)
imageViewer.CloseButton:SetPosition(displayWidth-16,0)
imageViewer.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay)

imageViewer.CloseButton.MouseClick=function()
	imageViewer:SetVisible(false)
end
if localPlayer:GetAlignment()==2 then
	imageViewer.CloseButton:SetBackground(0x41005f41)
else
	imageViewer.CloseButton:SetBackground(0x41000196)
end
