importPath=string.gsub(getfenv(1)._.Name,"%.OptionsWindow","").."."
if ColorPicker==nil then
	import (importPath.."ColorPicker")
end
local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+2
local hfont=GetLargerFont(Settings.Font)
local buttonFont=Settings.Font
while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
	-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
	buttonFont=GetSmallerFont(buttonFont)
end
if hfont==nil then hfont=Settings.Font end
fontMetric:SetFont(Settings.Font)
-- need to create the options window
OptionsWindow = Turbine.UI.Lotro.Window();
OptionsWindow:SetText(Resource[language][48]);
OptionsWindow:SetVisible(false);
OptionsWindow:SetSize(600,550);
OptionsWindow:SetPosition((displayWidth - OptionsWindow:GetWidth()) / 2,(displayHeight - OptionsWindow:GetHeight()) / 2);

OptionsWindow.HadErrors=false;

OptionsWindow.OptionsCaption=Turbine.UI.Label();
OptionsWindow.OptionsCaption:SetParent(OptionsWindow);
OptionsWindow.OptionsCaption:SetFont(hfont);
OptionsWindow.OptionsCaption:SetForeColor(Settings.HeadingColor);
OptionsWindow.OptionsCaption:SetSize(OptionsWindow:GetWidth(),Turbine.UI.Lotro.FontInfo[hfont].size+2);
OptionsWindow.OptionsCaption:SetPosition(0,40);
OptionsWindow.OptionsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
OptionsWindow.OptionsCaption:SetText(Resource[language][49]);

OptionsWindow.FontFaceCaption=Turbine.UI.Label();
OptionsWindow.FontFaceCaption:SetParent(OptionsWindow);
OptionsWindow.FontFaceCaption:SetPosition(10,OptionsWindow.OptionsCaption:GetTop()+OptionsWindow.OptionsCaption:GetHeight()+5);
OptionsWindow.FontFaceCaption:SetSize(OptionsWindow:GetWidth()-400,controlHeight);
OptionsWindow.FontFaceCaption:SetFont(Settings.Font);
OptionsWindow.FontFaceCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.FontFaceCaption:SetText(Resource[language][50]..":");
OptionsWindow.FontLabel=Turbine.UI.Label()
OptionsWindow.FontLabel:SetParent(OptionsWindow)
OptionsWindow.FontLabel:SetFont(Settings.Font)
OptionsWindow.FontLabel.MouseClick=function()
	OptionsWindow.FontSelect:MouseClick()
end
OptionsWindow.FontLabel:SetPosition(OptionsWindow.FontFaceCaption:GetLeft()+OptionsWindow.FontFaceCaption:GetWidth()+5,OptionsWindow.FontFaceCaption:GetTop())
OptionsWindow.FontLabel:SetText(Turbine.UI.Lotro.FontInfo[Settings.Font].name.." "..tostring(Turbine.UI.Lotro.FontInfo[Settings.Font].size))
OptionsWindow.FontLabel:SetSize(fontMetric:GetTextWidth(OptionsWindow.FontLabel:GetText()),controlHeight)
OptionsWindow.FontSelect=FontSelect()
OptionsWindow.FontSelect:SetParent(OptionsWindow)
OptionsWindow.FontSelect:SetSize(0,0)
OptionsWindow.FontSelect:SetPosition(OptionsWindow.FontLabel:GetLeft(),OptionsWindow.FontLabel:GetTop())
OptionsWindow.FontSelect:SetFont(Settings.Font)
OptionsWindow.FontSelect.FontChanged=function(sender,args)
	OptionsWindow:SetFont(OptionsWindow.FontSelect:GetFont())
end

OptionsWindow.OpacityCaption=Turbine.UI.Label();
OptionsWindow.OpacityCaption:SetParent(OptionsWindow);
OptionsWindow.OpacityCaption:SetPosition(10,OptionsWindow.FontFaceCaption:GetTop()+OptionsWindow.FontFaceCaption:GetHeight()+5);
OptionsWindow.OpacityCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.OpacityCaption:SetFont(Settings.Font);
OptionsWindow.OpacityCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.OpacityCaption:SetText(Resource[language][66]..":");
OptionsWindow.OpacityScrollbar=Turbine.UI.Lotro.ScrollBar();
OptionsWindow.OpacityScrollbar:SetOrientation(Turbine.UI.Orientation.Horizontal);
OptionsWindow.OpacityScrollbar:SetParent(OptionsWindow)
OptionsWindow.OpacityScrollbar:SetPosition(OptionsWindow.OpacityCaption:GetLeft()+OptionsWindow.OpacityCaption:GetWidth()+5,OptionsWindow.OpacityCaption:GetTop());
OptionsWindow.OpacityScrollbar:SetSize(OptionsWindow:GetWidth()-OptionsWindow.OpacityCaption:GetWidth()-OptionsWindow.OpacityCaption:GetLeft()-15,10);
OptionsWindow.OpacityScrollbar:SetBackColor(Turbine.UI.Color(0,0,0));
OptionsWindow.OpacityScrollbar:SetMinimum(0);
OptionsWindow.OpacityScrollbar:SetMaximum(100);
OptionsWindow.OpacityScrollbar.OriginalValue=Settings.Opacity*100
OptionsWindow.OpacityScrollbar:SetValue(Settings.Opacity*100)
OptionsWindow.OpacityScrollbar.ValueChanged=function()
end

OptionsWindow.ColorsCaption=Turbine.UI.Label();
OptionsWindow.ColorsCaption:SetParent(OptionsWindow);
OptionsWindow.ColorsCaption:SetFont(hfont);
OptionsWindow.ColorsCaption:SetForeColor(Settings.HeadingColor);
OptionsWindow.ColorsCaption:SetSize(OptionsWindow:GetWidth(),Turbine.UI.Lotro.FontInfo[hfont].size+2);
OptionsWindow.ColorsCaption:SetPosition(0,OptionsWindow.FontFaceCaption:GetTop()+OptionsWindow.OpacityCaption:GetHeight()+9);
OptionsWindow.ColorsCaption:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
OptionsWindow.ColorsCaption:SetText(Resource[language][53]);

OptionsWindow.FontCaption=Turbine.UI.Label();
OptionsWindow.FontCaption:SetParent(OptionsWindow);
OptionsWindow.FontCaption:SetPosition(10,OptionsWindow.ColorsCaption:GetTop()+OptionsWindow.ColorsCaption:GetHeight()+5);
OptionsWindow.FontCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.FontCaption:SetFont(Settings.Font);
OptionsWindow.FontCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.FontCaption:SetText(Resource[language][54]..":"); --"Font Color:");
OptionsWindow.FontColor=ColorPicker();
OptionsWindow.FontColor:SetParent(OptionsWindow);
OptionsWindow.FontColor:SetPosition(OptionsWindow.FontCaption:GetLeft()+OptionsWindow.FontCaption:GetWidth()+5,OptionsWindow.FontCaption:GetTop()-1);
OptionsWindow.FontColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.FontColor:SetColor(Settings.FontColor);
OptionsWindow.FontColor.ColorChanged=function()
	OptionsWindow:SetFontColor(OptionsWindow.FontColor:GetColor());
end

OptionsWindow.LabelCaption=Turbine.UI.Label();
OptionsWindow.LabelCaption:SetParent(OptionsWindow);
OptionsWindow.LabelCaption:SetPosition(10,OptionsWindow.FontCaption:GetTop()+OptionsWindow.FontCaption:GetHeight()+5);
OptionsWindow.LabelCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.LabelCaption:SetFont(Settings.Font);
OptionsWindow.LabelCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.LabelCaption:SetText(Resource[language][55]..":");
OptionsWindow.LabelColor=ColorPicker();
OptionsWindow.LabelColor:SetParent(OptionsWindow);
OptionsWindow.LabelColor:SetPosition(OptionsWindow.LabelCaption:GetLeft()+OptionsWindow.LabelCaption:GetWidth()+5,OptionsWindow.LabelCaption:GetTop()-1);
OptionsWindow.LabelColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.LabelColor:SetColor(Settings.LabelColor);
OptionsWindow.LabelColor.ColorChanged=function()
	OptionsWindow:SetLabelColor(OptionsWindow.LabelColor:GetColor());
end

OptionsWindow.HeadingCaption=Turbine.UI.Label();
OptionsWindow.HeadingCaption:SetParent(OptionsWindow);
OptionsWindow.HeadingCaption:SetPosition(10,OptionsWindow.LabelCaption:GetTop()+OptionsWindow.LabelCaption:GetHeight()+5);
OptionsWindow.HeadingCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.HeadingCaption:SetFont(Settings.Font);
OptionsWindow.HeadingCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.HeadingCaption:SetText(Resource[language][60]..":");
OptionsWindow.HeadingColor=ColorPicker();
OptionsWindow.HeadingColor:SetParent(OptionsWindow);
OptionsWindow.HeadingColor:SetPosition(OptionsWindow.HeadingCaption:GetLeft()+OptionsWindow.HeadingCaption:GetWidth()+5,OptionsWindow.HeadingCaption:GetTop()-1);
OptionsWindow.HeadingColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.HeadingColor:SetColor(Settings.HeadingColor);
OptionsWindow.HeadingColor.ColorChanged=function()
	OptionsWindow:SetHeadingColor(OptionsWindow.HeadingColor:GetColor());
end

-- trim color
OptionsWindow.TrimCaption=Turbine.UI.Label();
OptionsWindow.TrimCaption:SetParent(OptionsWindow);
OptionsWindow.TrimCaption:SetPosition(10,OptionsWindow.HeadingCaption:GetTop()+OptionsWindow.HeadingCaption:GetHeight()+5);
OptionsWindow.TrimCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.TrimCaption:SetFont(Settings.Font);
OptionsWindow.TrimCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.TrimCaption:SetText(Resource[language][51]..":");
OptionsWindow.TrimColor=ColorPicker();
OptionsWindow.TrimColor:SetParent(OptionsWindow);
OptionsWindow.TrimColor:SetPosition(OptionsWindow.TrimCaption:GetLeft()+OptionsWindow.TrimCaption:GetWidth()+5,OptionsWindow.TrimCaption:GetTop()-1);
OptionsWindow.TrimColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.TrimColor:SetColor(Settings.TrimColor);
OptionsWindow.TrimColor.ColorChanged=function()
	OptionsWindow:SetTrimColor(OptionsWindow.TrimColor:GetColor());
end

OptionsWindow.BackCaption=Turbine.UI.Label();
OptionsWindow.BackCaption:SetParent(OptionsWindow);
OptionsWindow.BackCaption:SetPosition(10,OptionsWindow.TrimColor:GetTop()+OptionsWindow.TrimColor:GetHeight()+5);
OptionsWindow.BackCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.BackCaption:SetFont(Settings.Font);
OptionsWindow.BackCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.BackCaption:SetText(Resource[language][56]..":");
OptionsWindow.BackColor=ColorPicker();
OptionsWindow.BackColor:SetParent(OptionsWindow);
OptionsWindow.BackColor:SetPosition(OptionsWindow.BackCaption:GetLeft()+OptionsWindow.BackCaption:GetWidth()+5,OptionsWindow.BackCaption:GetTop()-1);
OptionsWindow.BackColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.BackColor:SetColor(Settings.BackColor);
OptionsWindow.BackColor.ColorChanged=function()
	OptionsWindow:SetBackColor(OptionsWindow.BackColor:GetColor());
end

OptionsWindow.TabSelectedCaption=Turbine.UI.Label();
OptionsWindow.TabSelectedCaption:SetParent(OptionsWindow);
OptionsWindow.TabSelectedCaption:SetPosition(10,OptionsWindow.BackColor:GetTop()+OptionsWindow.BackColor:GetHeight()+5);
OptionsWindow.TabSelectedCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.TabSelectedCaption:SetFont(Settings.Font);
OptionsWindow.TabSelectedCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.TabSelectedCaption:SetText(Resource[language][58]..":");
OptionsWindow.TabSelectedColor=ColorPicker();
OptionsWindow.TabSelectedColor:SetParent(OptionsWindow);
OptionsWindow.TabSelectedColor:SetPosition(OptionsWindow.TabSelectedCaption:GetLeft()+OptionsWindow.TabSelectedCaption:GetWidth()+5,OptionsWindow.TabSelectedCaption:GetTop()-1);
OptionsWindow.TabSelectedColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.TabSelectedColor:SetColor(Settings.TabSelectedColor);
OptionsWindow.TabSelectedColor.ColorChanged=function()
	OptionsWindow:SetTabSelectedColor(OptionsWindow.TabSelectedColor:GetColor());
end

OptionsWindow.TabUnSelectedCaption=Turbine.UI.Label();
OptionsWindow.TabUnSelectedCaption:SetParent(OptionsWindow);
OptionsWindow.TabUnSelectedCaption:SetPosition(10,OptionsWindow.TabSelectedColor:GetTop()+OptionsWindow.TabSelectedColor:GetHeight()+5);
OptionsWindow.TabUnSelectedCaption:SetSize(OptionsWindow.FontFaceCaption:GetWidth(),controlHeight);
OptionsWindow.TabUnSelectedCaption:SetFont(Settings.Font);
OptionsWindow.TabUnSelectedCaption:SetForeColor(Settings.LabelColor);
OptionsWindow.TabUnSelectedCaption:SetText(Resource[language][59]..":");
OptionsWindow.TabUnSelectedColor=ColorPicker();
OptionsWindow.TabUnSelectedColor:SetParent(OptionsWindow);
OptionsWindow.TabUnSelectedColor:SetPosition(OptionsWindow.TabUnSelectedCaption:GetLeft()+OptionsWindow.TabUnSelectedCaption:GetWidth()+5,OptionsWindow.TabUnSelectedCaption:GetTop()-1);
OptionsWindow.TabUnSelectedColor:SetTrimColor(Settings.TrimColor);
OptionsWindow.TabUnSelectedColor:SetColor(Settings.TabUnSelectedColor);
OptionsWindow.TabUnSelectedColor.ColorChanged=function()
	OptionsWindow:SetTabUnSelectedColor(OptionsWindow.TabUnSelectedColor:GetColor());
end

OptionsWindow.ColorNote=Turbine.UI.Label()
OptionsWindow.ColorNote:SetParent(OptionsWindow)
OptionsWindow.ColorNote:SetFont(Turbine.UI.Lotro.Font.Verdana14)
OptionsWindow.ColorNote:SetSize(OptionsWindow:GetWidth(),15)
OptionsWindow.ColorNote:SetPosition(0,OptionsWindow.TabUnSelectedCaption:GetTop()+OptionsWindow.TabUnSelectedCaption:GetHeight()+5)
OptionsWindow.ColorNote:SetText(Resource[language][57])
OptionsWindow.ColorNote:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);

OptionsWindow.ResetColors=Turbine.UI.Lotro.Button();
OptionsWindow.ResetColors:SetParent(OptionsWindow);
fontMetric:SetFont(buttonFont)
OptionsWindow.ResetColors:SetSize(fontMetric:GetTextWidth(Resource[language][65])+20,20);
OptionsWindow.ResetColors:SetFont(buttonFont)
OptionsWindow.ResetColors:SetPosition((OptionsWindow:GetWidth()-OptionsWindow.ResetColors:GetWidth())/2,OptionsWindow.ColorNote:GetTop()+OptionsWindow.ColorNote:GetHeight()+5);
OptionsWindow.ResetColors:SetText(Resource[language][65]);
OptionsWindow.ResetColors.Click=function()
	OptionsWindow.FontColor:SetColor(Turbine.UI.Color.White)
	OptionsWindow.BackColor:SetColor(Turbine.UI.Color.Black)
	OptionsWindow.HeadingColor:SetColor(Turbine.UI.Color.LightBlue)
	OptionsWindow.LabelColor:SetColor(Turbine.UI.Color(.843,.698,.227))
	OptionsWindow.TabSelectedColor:SetColor(Turbine.UI.Color.LightBlue)
	OptionsWindow.TabUnSelectedColor:SetColor(Turbine.UI.Color(.2,.25,1))
	OptionsWindow.TrimColor:SetColor(Turbine.UI.Color(.15,.15,.25))

end

OptionsWindow.LoadLastStory=Turbine.UI.Lotro.CheckBox();
OptionsWindow.LoadLastStory:SetParent(OptionsWindow);
OptionsWindow.LoadLastStory:SetForeColor(Settings.LabelColor);
OptionsWindow.LoadLastStory:SetText(Resource[language][198]);

--[[

-- Load Minimized
OptionsWindow.LoadMinimizedCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.LoadMinimizedCB:SetParent(OptionsWindow);
OptionsWindow.LoadMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.LoadMinimizedCB:SetForeColor(Settings.FontColor);
OptionsWindow.LoadMinimizedCB:SetSize(OptionsWindow:GetWidth()-15,18);
OptionsWindow.LoadMinimizedCB:SetPosition(10,OptionsWindow.OpacityCaption:GetTop()+OptionsWindow.OpacityCaption:GetHeight()+4);
OptionsWindow.LoadMinimizedCB:SetText(Resource[language][17]);

-- Show Icon when Minimized
OptionsWindow.ShowIconWhenMinimizedCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.ShowIconWhenMinimizedCB:SetParent(OptionsWindow);
OptionsWindow.ShowIconWhenMinimizedCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.ShowIconWhenMinimizedCB:SetForeColor(Settings.FontColor);
OptionsWindow.ShowIconWhenMinimizedCB:SetSize(OptionsWindow:GetWidth()-15,18);
OptionsWindow.ShowIconWhenMinimizedCB:SetPosition(10,OptionsWindow.LoadMinimizedCB:GetTop()+OptionsWindow.LoadMinimizedCB:GetHeight()+4);
OptionsWindow.ShowIconWhenMinimizedCB:SetText(Resource[language][18]);

-- Use 16x16 Icon
OptionsWindow.UseMiniIconCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.UseMiniIconCB:SetParent(OptionsWindow);
OptionsWindow.UseMiniIconCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.UseMiniIconCB:SetForeColor(Settings.FontColor);
OptionsWindow.UseMiniIconCB:SetSize(OptionsWindow:GetWidth()-15,18);
OptionsWindow.UseMiniIconCB:SetPosition(10,OptionsWindow.ShowIconWhenMinimizedCB:GetTop()+OptionsWindow.ShowIconWhenMinimizedCB:GetHeight()+4);
OptionsWindow.UseMiniIconCB:SetText(Resource[language][201]);

-- Mini Icon is opaque
OptionsWindow.MiniIconOpaqueCB=Turbine.UI.Lotro.CheckBox();
OptionsWindow.MiniIconOpaqueCB:SetParent(OptionsWindow);
OptionsWindow.MiniIconOpaqueCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
OptionsWindow.MiniIconOpaqueCB:SetForeColor(Settings.FontColor);
OptionsWindow.MiniIconOpaqueCB:SetSize(OptionsWindow:GetWidth()-15,18);
OptionsWindow.MiniIconOpaqueCB:SetPosition(30,OptionsWindow.UseMiniIconCB:GetTop()+OptionsWindow.UseMiniIconCB:GetHeight()+4);
OptionsWindow.MiniIconOpaqueCB:SetText(Resource[language][202]);

OptionsWindow.Update=function(sender,args)
	if OptionsWindow.HadErrors then
		if Turbine.Engine:GetGameTime()>OptionsWindow.ErrorFadeTime then
			OptionsWindow:SetWantsUpdates(false);
			OptionsWindow.ErrorLabel:SetVisible(false);
			OptionsWindow.HadErrors=false
		end
	end
end

--]]

OptionsWindow.SaveButton=Turbine.UI.Lotro.Button();
OptionsWindow.SaveButton:SetParent(OptionsWindow);
OptionsWindow.SaveButton:SetSize(100,20);
OptionsWindow.SaveButton:SetPosition(30,OptionsWindow.ResetColors:GetTop()+OptionsWindow.ResetColors:GetHeight()+9);
OptionsWindow.SaveButton:SetFont(buttonFont)
OptionsWindow.SaveButton:SetText(Resource[language][16]);
OptionsWindow.SaveButton.Click=function()
	local hasError=false;
--	Settings.LoadMinimized=OptionsWindow.LoadMinimizedCB:IsChecked();
--	Settings.UseMiniIcon=OptionsWindow.UseMiniIconCB:IsChecked();
--	Settings.ShowIconWhenMinimized=OptionsWindow.ShowIconWhenMinimizedCB:IsChecked();
		-- if plugin is currently minimized (user hit escape with options open), show the icon if set

	Settings.Font=OptionsWindow.FontSelect:GetFont()
	Settings.FontColor=OptionsWindow.FontColor:GetColor()

	Settings.LabelColor=OptionsWindow.LabelColor:GetColor()
	Settings.HeadingColor=OptionsWindow.HeadingColor:GetColor()
	Settings.TrimColor=OptionsWindow.TrimColor:GetColor()
	Settings.BackColor=OptionsWindow.BackColor:GetColor()
	Settings.TabSelectedColor=OptionsWindow.TabSelectedColor:GetColor()
	Settings.TabUnSelectedColor=OptionsWindow.TabUnSelectedColor:GetColor()
	Settings.Opacity=OptionsWindow.OpacityScrollbar:GetValue()/100
	Settings.LoadLastStory=OptionsWindow.LoadLastStory:IsChecked()

	mainWindow:RefreshLayout()
	mainWindow:RefreshColor()

	-- need to save options to plugindata without destroying other settings
	SaveSetting("Account",pluginName.."Settings","","Font",Settings.Font)
	SaveSetting("Account",pluginName.."Settings","FontColor","",Settings.FontColor,true)
	SaveSetting("Account",pluginName.."Settings","LabelColor","",Settings.LabelColor,true)
	SaveSetting("Account",pluginName.."Settings","TrimColor","",Settings.TrimColor,true)
	SaveSetting("Account",pluginName.."Settings","BackColor","",Settings.BackColor,true)
	SaveSetting("Account",pluginName.."Settings","TabSelectedColor","",Settings.TabSelectedColor,true)
	SaveSetting("Account",pluginName.."Settings","TabUnSelectedColor","",Settings.TabUnSelectedColor,true)
	SaveSetting("Account",pluginName.."Settings","","Opacity",Settings.Opacity)
	SaveSetting("Account",pluginName.."Settings","","LoadLastStory",Settings.LoadLastStory)

	OptionsWindow:SetVisible(false);
	currentWindow.MouseMask:SetMouseVisible(false)
end

OptionsWindow.CancelButton=Turbine.UI.Lotro.Button();
OptionsWindow.CancelButton:SetParent(OptionsWindow);
OptionsWindow.CancelButton:SetSize(100,20);
OptionsWindow.CancelButton:SetPosition(OptionsWindow:GetWidth()-30-OptionsWindow.CancelButton:GetWidth(),OptionsWindow.SaveButton:GetTop());
OptionsWindow.CancelButton:SetFont(buttonFont)
OptionsWindow.CancelButton:SetText(Resource[language][19]);
OptionsWindow.CancelButton.Click=function()
	OptionsWindow.Closed()
end
OptionsWindow.ErrorLabel=Turbine.UI.Label();
OptionsWindow.ErrorLabel:SetParent(OptionsWindow);
OptionsWindow.ErrorLabel:SetText("Adjusted Invalid Values")
OptionsWindow.ErrorLabel:SetPosition(OptionsWindow.SaveButton:GetLeft()+OptionsWindow.SaveButton:GetWidth(),OptionsWindow.SaveButton:GetTop());
OptionsWindow.ErrorLabel:SetSize(OptionsWindow.CancelButton:GetLeft()-(OptionsWindow.ErrorLabel:GetLeft()),OptionsWindow.SaveButton:GetHeight());
OptionsWindow.ErrorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro18);
OptionsWindow.ErrorLabel:SetForeColor(Turbine.UI.Color(1,0,0));
OptionsWindow.ErrorLabel:SetVisible(false);
OptionsWindow.ErrorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

OptionsWindow.SetFont=function(sender,font)
	local hfont=GetLargerFont(font)
	local controlHeight=Turbine.UI.Lotro.FontInfo[font].size+2
	local buttonFont=font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	if hfont==nil then hfont=font end
	-- set font and resize/reposition controls
	OptionsWindow.OptionsCaption:SetFont(hfont);
	OptionsWindow.OptionsCaption:SetText(OptionsWindow.OptionsCaption:GetText());
	OptionsWindow.OptionsCaption:SetHeight(Turbine.UI.Lotro.FontInfo[hfont].size+2)
	OptionsWindow.FontFaceCaption:SetFont(font);
	OptionsWindow.FontFaceCaption:SetText(OptionsWindow.FontFaceCaption:GetText());
	OptionsWindow.FontFaceCaption:SetTop(OptionsWindow.OptionsCaption:GetTop()+OptionsWindow.OptionsCaption:GetHeight()+5);
	OptionsWindow.FontFaceCaption:SetHeight(controlHeight);
	OptionsWindow.FontSelect:SetHeight(controlHeight)
	OptionsWindow.FontSelect:SetTop(OptionsWindow.FontFaceCaption:GetTop())
	OptionsWindow.FontLabel:SetFont(font)
	fontMetric:SetFont(font)
	OptionsWindow.FontLabel:SetTop(OptionsWindow.FontFaceCaption:GetTop())
	OptionsWindow.FontLabel:SetText(Turbine.UI.Lotro.FontInfo[font].name.." "..tostring(Turbine.UI.Lotro.FontInfo[font].size))
	OptionsWindow.FontLabel:SetSize(fontMetric:GetTextWidth(OptionsWindow.FontLabel:GetText()),controlHeight)
	OptionsWindow.FontSelect:SetPosition(OptionsWindow.FontLabel:GetLeft(),OptionsWindow.FontLabel:GetTop())

	OptionsWindow.OpacityCaption:SetFont(font);
	OptionsWindow.OpacityCaption:SetText(OptionsWindow.OpacityCaption:GetText());
	OptionsWindow.OpacityCaption:SetTop(OptionsWindow.FontFaceCaption:GetTop()+OptionsWindow.FontFaceCaption:GetHeight()+5);
	OptionsWindow.OpacityCaption:SetHeight(controlHeight);
	OptionsWindow.OpacityScrollbar:SetTop(OptionsWindow.OpacityCaption:GetTop()-1);

	OptionsWindow.ColorsCaption:SetFont(hfont)
	OptionsWindow.ColorsCaption:SetText(OptionsWindow.ColorsCaption:GetText());
	OptionsWindow.ColorsCaption:SetHeight(Turbine.UI.Lotro.FontInfo[hfont].size+2)
	OptionsWindow.ColorsCaption:SetPosition(0,OptionsWindow.OpacityCaption:GetTop()+OptionsWindow.OpacityCaption:GetHeight()+9);

	OptionsWindow.FontCaption:SetFont(font);
	OptionsWindow.FontCaption:SetText(OptionsWindow.FontCaption:GetText());
	OptionsWindow.FontCaption:SetTop(OptionsWindow.ColorsCaption:GetTop()+OptionsWindow.ColorsCaption:GetHeight()+5);
	OptionsWindow.FontCaption:SetHeight(controlHeight);
	OptionsWindow.FontColor:SetTop(OptionsWindow.FontCaption:GetTop()-1);

	OptionsWindow.LabelCaption:SetFont(font);
	OptionsWindow.LabelCaption:SetText(OptionsWindow.LabelCaption:GetText());
	OptionsWindow.LabelCaption:SetTop(OptionsWindow.FontCaption:GetTop()+OptionsWindow.FontCaption:GetHeight()+5);
	OptionsWindow.LabelCaption:SetHeight(controlHeight);
	OptionsWindow.LabelColor:SetTop(OptionsWindow.LabelCaption:GetTop()-1);

	OptionsWindow.HeadingCaption:SetFont(font);
	OptionsWindow.HeadingCaption:SetText(OptionsWindow.HeadingCaption:GetText());
	OptionsWindow.HeadingCaption:SetTop(OptionsWindow.LabelCaption:GetTop()+OptionsWindow.LabelCaption:GetHeight()+5);
	OptionsWindow.HeadingCaption:SetHeight(controlHeight);
	OptionsWindow.HeadingColor:SetTop(OptionsWindow.HeadingCaption:GetTop()-1);

	OptionsWindow.TrimCaption:SetFont(font);
	OptionsWindow.TrimCaption:SetText(OptionsWindow.TrimCaption:GetText());
	OptionsWindow.TrimCaption:SetTop(OptionsWindow.HeadingCaption:GetTop()+OptionsWindow.HeadingCaption:GetHeight()+5);
	OptionsWindow.TrimCaption:SetHeight(controlHeight);
	OptionsWindow.TrimColor:SetTop(OptionsWindow.TrimCaption:GetTop()-1);

	OptionsWindow.BackCaption:SetFont(font);
	OptionsWindow.BackCaption:SetText(OptionsWindow.BackCaption:GetText());
	OptionsWindow.BackCaption:SetTop(OptionsWindow.TrimCaption:GetTop()+OptionsWindow.TrimCaption:GetHeight()+5);
	OptionsWindow.BackCaption:SetHeight(controlHeight);
	OptionsWindow.BackColor:SetTop(OptionsWindow.BackCaption:GetTop()-1);

	OptionsWindow.TabSelectedCaption:SetFont(font);
	OptionsWindow.TabSelectedCaption:SetText(OptionsWindow.TabSelectedCaption:GetText());
	OptionsWindow.TabSelectedCaption:SetTop(OptionsWindow.BackCaption:GetTop()+OptionsWindow.BackCaption:GetHeight()+5);
	OptionsWindow.TabSelectedCaption:SetHeight(controlHeight);
	OptionsWindow.TabSelectedColor:SetTop(OptionsWindow.TabSelectedCaption:GetTop()-1);

	OptionsWindow.TabUnSelectedCaption:SetFont(font);
	OptionsWindow.TabUnSelectedCaption:SetText(OptionsWindow.TabUnSelectedCaption:GetText());
	OptionsWindow.TabUnSelectedCaption:SetTop(OptionsWindow.TabSelectedCaption:GetTop()+OptionsWindow.TabSelectedCaption:GetHeight()+5);
	OptionsWindow.TabUnSelectedCaption:SetHeight(controlHeight);
	OptionsWindow.TabUnSelectedColor:SetTop(OptionsWindow.TabUnSelectedCaption:GetTop()-1);

	OptionsWindow.ColorNote:SetTop(OptionsWindow.TabUnSelectedCaption:GetTop()+OptionsWindow.TabUnSelectedCaption:GetHeight()+5);

	fontMetric:SetFont(buttonFont)
	OptionsWindow.ResetColors:SetSize(fontMetric:GetTextWidth(Resource[language][65])+20,20);
	OptionsWindow.ResetColors:SetFont(buttonFont)
	OptionsWindow.ResetColors:SetPosition((OptionsWindow:GetWidth()-OptionsWindow.ResetColors:GetWidth())/2,OptionsWindow.ColorNote:GetTop()+OptionsWindow.ColorNote:GetHeight()+5);
	OptionsWindow.ResetColors:SetText(Resource[language][65]);

	OptionsWindow.LoadLastStory:SetFont(Settings.Font);
	OptionsWindow.LoadLastStory:SetSize(OptionsWindow:GetWidth()-20,controlHeight);
	OptionsWindow.LoadLastStory:SetPosition(10,OptionsWindow.ResetColors:GetTop()+OptionsWindow.ResetColors:GetHeight()+5);

	OptionsWindow.SaveButton:SetFont(buttonFont)
	OptionsWindow.SaveButton:SetText(OptionsWindow.SaveButton:GetText())
	OptionsWindow.SaveButton:SetTop(OptionsWindow.LoadLastStory:GetTop()+OptionsWindow.LoadLastStory:GetHeight()+9);

	OptionsWindow.CancelButton:SetFont(buttonFont)
	OptionsWindow.CancelButton:SetText(OptionsWindow.CancelButton:GetText())
	OptionsWindow.CancelButton:SetPosition(OptionsWindow:GetWidth()-30-OptionsWindow.CancelButton:GetWidth(),OptionsWindow.SaveButton:GetTop());

	-- set new window height
	OptionsWindow:SetHeight(OptionsWindow.CancelButton:GetTop()+OptionsWindow.CancelButton:GetHeight()+20)
end
OptionsWindow:SetFont(Settings.Font)

OptionsWindow.SetHeadingColor=function(sender,color)
	OptionsWindow.OptionsCaption:SetForeColor(color)
	OptionsWindow.ColorsCaption:SetForeColor(color)
end
OptionsWindow.SetTrimColor=function(sender,color)
	OptionsWindow.FontColor:SetTrimColor(color)
	OptionsWindow.LabelColor:SetTrimColor(color)
	OptionsWindow.HeadingColor:SetTrimColor(color)
	OptionsWindow.TrimColor:SetTrimColor(color)
	OptionsWindow.BackColor:SetTrimColor(color)
	OptionsWindow.TabSelectedColor:SetTrimColor(color)
	OptionsWindow.TabUnSelectedColor:SetTrimColor(color)
end
OptionsWindow.SetFontColor=function(sender,color)
	OptionsWindow.FontLabel:SetForeColor(color)
end
OptionsWindow.SetBackColor=function(sender,color)
end
OptionsWindow.SetTabSelectedColor=function(sender,color)
end
OptionsWindow.SetTabUnSelectedColor=function(sender,color)
end
OptionsWindow.SetLabelColor=function(sender,color)
	OptionsWindow.FontFaceCaption:SetForeColor(color);
	OptionsWindow.FontCaption:SetForeColor(color);
	OptionsWindow.LabelCaption:SetForeColor(color);
	OptionsWindow.TrimCaption:SetForeColor(color);
	OptionsWindow.OpacityCaption:SetForeColor(color);
	OptionsWindow.HeadingCaption:SetForeColor(color);
	OptionsWindow.BackCaption:SetForeColor(color);
	OptionsWindow.TabSelectedCaption:SetForeColor(color);
	OptionsWindow.TabUnSelectedCaption:SetForeColor(color);
	OptionsWindow.LoadLastStory:SetForeColor(Settings.LabelColor);
end

OptionsWindow.VisibleChanged=function(sender,args)
	if OptionsWindow:IsVisible() then
		-- refresh the options status to reflect current values
		OptionsWindow.OpacityScrollbar:SetValue(Settings.Opacity*100)
		OptionsWindow.OpacityScrollbar.OriginalValue=Settings.Opacity*100
		OptionsWindow.FontSelect:SetFont(Settings.Font)
		OptionsWindow.FontColor:SetColor(Settings.FontColor)
		OptionsWindow.LabelColor:SetColor(Settings.LabelColor)
		OptionsWindow.TrimColor:SetColor(Settings.TrimColor)
		OptionsWindow.BackColor:SetColor(Settings.BackColor)
		OptionsWindow.TabSelectedColor:SetColor(Settings.TabSelectedColor)
		OptionsWindow.TabUnSelectedColor:SetColor(Settings.TabUnSelectedColor)
		OptionsWindow.LoadLastStory:SetChecked(Settings.LoadLastStory)
	end
end

OptionsWindow.Closed=function()
	-- reset font and color controls
	OptionsWindow:SetVisible(false);
	currentWindow.MouseMask:SetMouseVisible(false)
end
OptionsWindow:SetZOrder(1)
controlHeight=nil
hfont=nil
buttonFont=nil