importPath=string.gsub(getfenv(1)._.Name,"%.Reader","").."."
resourcePath=string.gsub(importPath,"%.","/").."Resources/"
storyPath=string.gsub(importPath,"%.","/").."Stories/"

-- reader is now a seperate plugin.
-- need to unload main

pluginName="Anthology"
import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";

language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end

getRaceName=function(race)
	local ret
	if race==Turbine.Gameplay.Race.Beorning then
		ret=Resource[language][133]
	elseif race==Turbine.Gameplay.Race.Dwarf then
		ret=Resource[language][134]
	elseif race==Turbine.Gameplay.Race.Elf then
		ret=Resource[language][135]
	elseif race==Turbine.Gameplay.Race.HighElf then
		ret=Resource[language][136]
	elseif race==Turbine.Gameplay.Race.Hobbit then
		ret=Resource[language][137]
	elseif race==Turbine.Gameplay.Race.Man then
		ret=Resource[language][138]
	elseif race==6 then --uruk
		ret=Resource[language][139]
	elseif race==7 then -- orc
		ret=Resource[language][140]
	elseif race==74 then -- Dunedain
		ret=Resource[language][141]
	elseif race==66 then -- warg
		ret=Resource[language][142]
	elseif race==66 then -- spider
		ret=Resource[language][143]
	elseif race==27 then -- chicken
		ret=Resource[language][144]
	else
		-- troll?
		ret=Resource[language][145]
	end
	return ret
end
getClassName=function(class)
	local ret
	if class==Turbine.Gameplay.Class.Beorning then
		ret=Resource[language][133]
	elseif class==Turbine.Gameplay.Class.BlackArrow then
		ret=Resource[language][146]
	elseif class==Turbine.Gameplay.Class.Burglar then
		ret=Resource[language][147]
	elseif class==Turbine.Gameplay.Class.Captain then
		ret=Resource[language][148]
	elseif class==Turbine.Gameplay.Class.Champion then
		ret=Resource[language][149]
	elseif class==Turbine.Gameplay.Class.Chicken then
		ret=Resource[language][144]
	elseif class==Turbine.Gameplay.Class.Defiler then
		ret=Resource[language][150]
	elseif class==Turbine.Gameplay.Class.Guardian then
		ret=Resource[language][151]
	elseif class==Turbine.Gameplay.Class.Hunter then
		ret=Resource[language][152]
	elseif class==Turbine.Gameplay.Class.LoreMaster then
		ret=Resource[language][153]
	elseif class==Turbine.Gameplay.Class.Minstrel then
		ret=Resource[language][154]
	elseif class==Turbine.Gameplay.Class.Ranger then
		ret=Resource[language][155]
	elseif class==Turbine.Gameplay.Class.Reaver then
		ret=Resource[language][156]
	elseif class==Turbine.Gameplay.Class.RuneKeeper then
		ret=Resource[language][157]
	elseif class==Turbine.Gameplay.Class.Stalker then
		ret=Resource[language][158]
	elseif class==Turbine.Gameplay.Class.Troll then
		ret=Resource[language][145]
	elseif class==Turbine.Gameplay.Class.Warden then
		ret=Resource[language][159]
	elseif class==Turbine.Gameplay.Class.WarLeader then
		ret=Resource[language][160]
	elseif class==Turbine.Gameplay.Class.Weaver then
		ret=Resource[language][161]
	else
		ret="professional" -- undefined class
	end
	return ret
end

displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()
localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
localPlayer.Name=localPlayer:GetName()
localPlayer.RaceName=getRaceName(localPlayer:GetRace())
localPlayer.ClassName=getClassName(localPlayer:GetClass())

if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

-- load saved settings - we need this in Main because this supports the OptionsWindow
Settings=PatchDataLoad(Turbine.DataScope.Account, pluginName.."Settings")
if Settings==nil then Settings={} end
if Settings.DataVersion==nil then
	Settings.DataVersion=plugin:GetVersion()
end
if Settings.MaxID==nil then
	Settings.MaxID=0
end
if Settings.Font==nil then
	Settings.Font=Turbine.UI.Lotro.Font.Verdana18
end
if Settings.FontColor==nil then
	Settings.FontColor=Turbine.UI.Color.White
else
	Settings.FontColor=Turbine.UI.Color(euroNormalize(Settings.FontColor.A),euroNormalize(Settings.FontColor.R),euroNormalize(Settings.FontColor.G),euroNormalize(Settings.FontColor.B))
end
if Settings.BackColor==nil then
	Settings.BackColor=Turbine.UI.Color.Black
else
	Settings.BackColor=Turbine.UI.Color(euroNormalize(Settings.BackColor.A),euroNormalize(Settings.BackColor.R),euroNormalize(Settings.BackColor.G),euroNormalize(Settings.BackColor.B))
end
if Settings.HeadingColor==nil then
	Settings.HeadingColor=Turbine.UI.Color.LightBlue
else
	Settings.HeadingColor=Turbine.UI.Color(euroNormalize(Settings.HeadingColor.A),euroNormalize(Settings.HeadingColor.R),euroNormalize(Settings.HeadingColor.G),euroNormalize(Settings.HeadingColor.B))
end
if Settings.LabelColor==nil then
	Settings.LabelColor=Turbine.UI.Color(.843,.698,.227)
else
	Settings.LabelColor=Turbine.UI.Color(euroNormalize(Settings.LabelColor.A),euroNormalize(Settings.LabelColor.R),euroNormalize(Settings.LabelColor.G),euroNormalize(Settings.LabelColor.B))
end
if Settings.TabSelectedColor==nil then
	Settings.TabSelectedColor=Turbine.UI.Color.LightBlue
else
	-- we have to euroNormalize the colors in case the calling plugin doesn't support font colors
	Settings.TabSelectedColor=Turbine.UI.Color(euroNormalize(Settings.TabSelectedColor.A),euroNormalize(Settings.TabSelectedColor.R),euroNormalize(Settings.TabSelectedColor.G),euroNormalize(Settings.TabSelectedColor.B))
end
if Settings.TabUnSelectedColor==nil then
	Settings.TabUnSelectedColor=Turbine.UI.Color(.2,.25,1)
else
	-- we have to euroNormalize the colors in case the calling plugin doesn't support font colors
	Settings.TabUnSelectedColor=Turbine.UI.Color(euroNormalize(Settings.TabUnSelectedColor.A),euroNormalize(Settings.TabUnSelectedColor.R),euroNormalize(Settings.TabUnSelectedColor.G),euroNormalize(Settings.TabUnSelectedColor.B))
end

if Settings.TrimColor==nil then
	Settings.TrimColor=Turbine.UI.Color(.15,.15,.25)
else
	Settings.TrimColor=Turbine.UI.Color(euroNormalize(Settings.TrimColor.A),euroNormalize(Settings.TrimColor.R),euroNormalize(Settings.TrimColor.G),euroNormalize(Settings.TrimColor.B))
end

if Settings.LanguageEN==nil then
	Settings.LanguageEN=(locale == "en")
end
if Settings.LanguageDE==nil then
	Settings.LanguageDE=(locale == "de")
end
if Settings.LanguageFR==nil then
	Settings.LanguageFR=(locale == "fr")
end
if Settings.Opacity==nil then
	Settings.Opacity=1
else
	Settings.Opacity=euroNormalize(Settings.Opacity)
end

StoryList=PatchDataLoad(Turbine.DataScope.Account, pluginName.."StoryList");
if StoryList==nil then StoryList={} end
for k,v in ipairs(StoryList) do
	if v.ID==nil then
		v.ID=Settings.MaxID+1
		Settings.MaxID=v.ID
	end
	if v.ID>Settings.MaxID then Settings.MaxID=v.ID end
end
import (importPath.."DropDownList");
import (importPath.."RadioButtonGroup");
import (importPath.."FontSupport")
fontMetric=FontMetric()
fontMetric:SetFont(Settings.Font)
import (importPath.."DebugWindow");
import (importPath.."PopUpDialog");
import (importPath.."IconWindow")
import (importPath.."Settings")
import (importPath.."StorySelect")
import (importPath.."ImageViewer")

getStoryIndexFromID=function(id)
	local index
	for k,v in ipairs(StoryList) do
		if v.ID==id then
			index=k
			break
		end
	end
	return index
end

readerStory={}
readerStory.Chapters={}

readerWindow=Turbine.UI.Lotro.Window()
readerWindow:SetResizable(true)
readerWindow:SetMinimumSize(885,290)
readerWindow:SetOpacity(Settings.Opacity)
readerWindow.Paused=false
readerWindow.Callbacks={} -- table of active registered callbacks (we only register callbacks when a story is active and one or more of the objectives requires that callback)
if Settings.ReaderWindow==nil then
	Settings.ReaderWindow={}
end

if Settings.ReaderWindow.Width==nil then
	Settings.ReaderWindow.Width=.67
else
	Settings.ReaderWindow.Width=euroNormalize(Settings.ReaderWindow.Width)
end
if Settings.ReaderWindow.Height==nil then
	Settings.ReaderWindow.Height=.5
else
	Settings.ReaderWindow.Height=euroNormalize(Settings.ReaderWindow.Height)
end
if Settings.ReaderWindow.Top==nil then
	Settings.ReaderWindow.Top=(1-Settings.ReaderWindow.Height)/2
else
	Settings.ReaderWindow.Top=euroNormalize(Settings.ReaderWindow.Top)
end
if Settings.ReaderWindow.Left==nil then
	Settings.ReaderWindow.Left=(1-Settings.ReaderWindow.Height)/2
else
	Settings.ReaderWindow.Left=euroNormalize(Settings.ReaderWindow.Left)
end
if Settings.ReaderWindow.Width<(readerWindow:GetMinimumWidth()/displayWidth) then Settings.ReaderWindow.Width=readerWindow:GetMinimumWidth()/displayWidth end
if Settings.ReaderWindow.Height<(readerWindow:GetMinimumHeight()/displayHeight) then Settings.ReaderWindow.Height=readerWindow:GetMinimumHeight()/displayWidth end

if Settings.ReaderSplit==nil then
	Settings.ReaderSplit=1-(400/displayWidth)
else
	Settings.ReaderSplit=euroNormalize(Settings.ReaderSplit)
end

if Settings.LoadLastStory==nil then Settings.LoadLastStory=true end
if Settings.ReaderStoryID==nil and Settings.LoadLastStory and Settings.ReaderWindow.LastStory~=nil then
	readerWindow.currentStoryID=Settings.ReaderWindow.LastStory
	readerStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..readerWindow.currentStoryID)
	if readerStory==nil then readerStory={} end
elseif Settings.ReaderStoryID~=nil then
	readerWindow.currentStoryID=Settings.ReaderStoryID
	readerStory=PatchDataLoad(Turbine.DataScope.Account,pluginName.."Story"..readerWindow.currentStoryID)
end
if readerStory==nil then readerStory={} end
if readerStory.ImageRoot==nil then
	readerStory.ImageRoot=storyPath -- default image root to the story path
end
Settings.ImageRoot=readerStory.ImageRoot

readerWindow:SetSize(Settings.ReaderWindow.Width*displayWidth,Settings.ReaderWindow.Height*displayHeight)
readerWindow:SetPosition(Settings.ReaderWindow.Left*displayWidth,Settings.ReaderWindow.Top*displayHeight)

readerWindow:SetText(Resource[language][2].." - "..Resource[language][5])
readerWindow.Closed=function()
	iconWindow:SetVisible(true)
end

readerWindow.LoadButton=Turbine.UI.Lotro.Button()
readerWindow.LoadButton:SetParent(readerWindow)
readerWindow.LoadButton:SetHeight(20)
readerWindow.LoadButton:SetPosition(30,35)
readerWindow.LoadButton.Click=function()
	readerWindow.Message:SetText("")
	storySelect.currentStoryID=readerWindow.currentStoryID
	storySelect.ReturnSelected=readerWindow.StorySelected
	storySelect.FillStoryList(storySelect.StoryListBox.SortColumn)
	storySelect:SetVisible(true)
	readerWindow.MouseMask:SetMouseVisible(true) -- note, MouseMask is used to simulate modal dialogs
end

readerWindow.PauseButton=Turbine.UI.Lotro.Button()
readerWindow.PauseButton:SetParent(readerWindow)
readerWindow.PauseButton:SetHeight(20)
readerWindow.PauseButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.PauseButton.MouseEnter=function()
	if readerWindow.Paused then
		readerWindow.Message:SetText(Resource[language][116])
	else
		readerWindow.Message:SetText(Resource[language][115])
	end
end
readerWindow.PauseButton.MouseLeave=function()
	readerWindow.Message:SetText("")
end
readerWindow.PauseButton.Click=function()
	readerWindow.Paused=not readerWindow.Paused
	if readerWindow.Paused then
		readerWindow.PauseButton:SetText(Resource[language][74])
		-- disable all of the event handlers
		readerWindow.PausedMessage:SetVisible(true)
		for k,v in pairs(readerWindow.Callbacks) do
			RemoveCallback(v.Object,v.Event,v.Function)
		end
	else
		readerWindow.PauseButton:SetText(Resource[language][73])
		-- re-enable all of the event handlers
		readerWindow.PausedMessage:SetVisible(false)
		for k,v in pairs(readerWindow.Callbacks) do
			AddCallback(v.Object,v.Event,v.Function)
		end
		-- fire TargetChanged just in case we already have a target
		readerWindow.TargetChanged()
	end
	readerWindow.LoadButton:SetEnabled(not readerWindow.Paused)
	readerWindow.ResetButton:SetEnabled(not readerWindow.Paused)
	readerWindow.HistoryButton:SetEnabled(not readerWindow.Paused)
end
readerWindow.ResetButton=Turbine.UI.Lotro.Button()
readerWindow.ResetButton:SetParent(readerWindow)
readerWindow.ResetButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.ResetButton.Click=function()
	readerWindow.MouseMask:SetMouseVisible(true)
	confirmReset=PopUpDialog(Resource[language][80],Resource[language][81],4,Resource[language][32],Resource[language][19],nil,false,readerResetOK)
end
readerResetOK=function(flag)
	readerWindow.MouseMask:SetMouseVisible(false)
	if flag==1 then
		readerWindow.ActiveChapter=nil
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		StoryList[index].ActiveChapter=nil
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayStory()
		readerWindow.Message:SetText(Resource[language][79])
	end
	confirmReset=nil
end

readerWindow.HistoryButton=Turbine.UI.Lotro.Button()
readerWindow.HistoryButton:SetParent(readerWindow)
readerWindow.HistoryButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.HistoryButton.Click=function()
	-- show the History window, which will show all of the text of prior chapters and the choices with Status
	readerWindow.MouseMask:SetMouseVisible(true)
	infoPopUp=PopUpDialog("History Placeholder","The History window is not currently available. It will display all prior story text. The user will be able to read all of the story text that they already encountered and retrace their selected path.",4,Resource[language][32],nil,nil,false,readerWindow.CloseInfo)
end


readerWindow.MenuButton=Turbine.UI.Lotro.Button()
readerWindow.MenuButton:SetParent(readerWindow)
readerWindow.MenuButton:SetHeight(20)
readerWindow.MenuButton:SetTop(readerWindow.LoadButton:GetTop())
readerWindow.MenuButton.Click=function()
	SaveSetting("Account",pluginName.."Settings","","Mode","Menu") -- trigger reload
	-- need to save reader settings
	SaveSettings()
	SettingQueueCallback(loadMenu)
end
loadMenu=function()
	Turbine.PluginManager.LoadPlugin("Anthology")
	readerWindow:SetVisible(false)
end

readerWindow.Story=Turbine.UI.Label()
readerWindow.Story:SetParent(readerWindow)
readerWindow.Story:SetLeft(10)
readerWindow.Chapter=Turbine.UI.Label()
readerWindow.Chapter:SetParent(readerWindow)
readerWindow.Chapter:SetLeft(readerWindow.Story:GetLeft())

readerWindow.Split=Turbine.UI.Control()
readerWindow.Split:SetParent(readerWindow)
readerWindow.Split:SetWidth(4)
readerWindow.Split:SetBackground(resourcePath.."vsep.tga")
readerWindow.Split:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
readerWindow.Split.MouseDown=function(sender,args)
	readerWindow.MovingSplit=true
	readerWindow.SplitX=args.X
end
readerWindow.Split.MouseEnter=function()
	readerWindow.Message:SetText(Resource[language][114])
end
readerWindow.Split.MouseLeave=function()
	readerWindow.Message:SetText("")
end
readerWindow.Split.MouseUp=function(sender,args)
	readerWindow.MovingSplit=false
end
readerWindow.Split.MouseMove=function(sender,args)
	if readerWindow.MovingSplit then
		Settings.ReaderSplit=(readerWindow.Split:GetLeft()+args.X-readerWindow.SplitX)/readerWindow:GetWidth()
		if Settings.ReaderSplit>.9 then Settings.ReaderSplit=.9 end
		if Settings.ReaderSplit<.1 then Settings.ReaderSplit=.1 end
		readerWindow.RefreshLayout()
	end
end

readerWindow.TextBorder=Turbine.UI.Control()
readerWindow.TextBorder:SetParent(readerWindow)
readerWindow.TextBorder:SetLeft(10)
readerWindow.Text=Turbine.UI.ListBox()
readerWindow.Text:SetParent(readerWindow.TextBorder)
readerWindow.Text:SetPosition(1,1)
readerWindow.TextVScroll=Turbine.UI.Lotro.ScrollBar()
readerWindow.TextVScroll:SetParent(readerWindow)
readerWindow.TextVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
readerWindow.TextVScroll:SetWidth(10)
readerWindow.TextVScroll:SetTop(readerWindow.Text:GetTop())
readerWindow.Text:SetVerticalScrollBar(readerWindow.TextVScroll)

readerWindow.ObjectiveBorder=Turbine.UI.Control()
readerWindow.ObjectiveBorder:SetParent(readerWindow)
readerWindow.ObjectiveList=Turbine.UI.ListBox()
readerWindow.ObjectiveList:SetParent(readerWindow.ObjectiveBorder)
readerWindow.ObjectiveList:SetPosition(1,1)
readerWindow.ObjectiveListVScroll=Turbine.UI.Lotro.ScrollBar()
readerWindow.ObjectiveListVScroll:SetParent(readerWindow)
readerWindow.ObjectiveListVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
readerWindow.ObjectiveListVScroll:SetWidth(10)
readerWindow.ObjectiveList:SetVerticalScrollBar(readerWindow.ObjectiveListVScroll)

readerWindow.PausedMessage=Turbine.UI.Label()
readerWindow.PausedMessage:SetParent(readerWindow)
readerWindow.PausedMessage:SetText(Resource[language][75])
readerWindow.PausedMessage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
readerWindow.PausedMessage:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
readerWindow.PausedMessage:SetBackColor(Turbine.UI.Color(.7,0,0,0))
readerWindow.PausedMessage:SetVisible(false)

readerWindow.Message=Turbine.UI.Label()
readerWindow.Message:SetParent(readerWindow)
readerWindow.Message:SetLeft(30)
readerWindow.Message:SetForeColor(Turbine.UI.Color.Gray)

readerWindow.MouseMask=Turbine.UI.Control()
readerWindow.MouseMask:SetParent(readerWindow)
readerWindow.MouseMask:SetMouseVisible(false)
readerWindow.MouseMask:SetZOrder(2)
readerWindow.MouseMask:SetSize(readerWindow:GetSize())

readerWindow.RefreshLayout=function()
	local minButtonWidth=140
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	fontMetric:SetFont(buttonFont)
	local tmp=fontMetric:GetTextWidth(Resource[language][72])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][73])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][74])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][7])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][79])
	if tmp>minButtonWidth then minButtonWidth=tmp end
	tmp=fontMetric:GetTextWidth(Resource[language][88])
	if tmp>minButtonWidth then minButtonWidth=tmp end

	readerWindow.LoadButton:SetSize(minButtonWidth)
	readerWindow.LoadButton:SetFont(buttonFont)
	readerWindow.LoadButton:SetText(Resource[language][72])

	readerWindow.PauseButton:SetSize(minButtonWidth)
	readerWindow.PauseButton:SetLeft(readerWindow.LoadButton:GetLeft()+readerWindow.LoadButton:GetWidth()+5)
	readerWindow.PauseButton:SetFont(buttonFont)
	if readerWindow.Paused then
		readerWindow.PauseButton:SetText(Resource[language][74])
	else
		readerWindow.PauseButton:SetText(Resource[language][73])
	end

	readerWindow.ResetButton:SetSize(minButtonWidth)
	readerWindow.ResetButton:SetLeft(readerWindow.PauseButton:GetLeft()+readerWindow.PauseButton:GetWidth()+5)
	readerWindow.ResetButton:SetFont(buttonFont)
	readerWindow.ResetButton:SetText(Resource[language][79])

	readerWindow.HistoryButton:SetSize(minButtonWidth)
	readerWindow.HistoryButton:SetLeft(readerWindow.ResetButton:GetLeft()+readerWindow.ResetButton:GetWidth()+5)
	readerWindow.HistoryButton:SetFont(buttonFont)
	readerWindow.HistoryButton:SetText(Resource[language][88])

	readerWindow.MenuButton:SetSize(minButtonWidth)
	readerWindow.MenuButton:SetLeft(readerWindow:GetWidth()-readerWindow.MenuButton:GetWidth()-readerWindow.LoadButton:GetLeft())
	readerWindow.MenuButton:SetFont(buttonFont)
	readerWindow.MenuButton:SetText(Resource[language][7])

	readerWindow.Story:SetTop(readerWindow.LoadButton:GetTop()+readerWindow.LoadButton:GetHeight()+5)
	readerWindow.Story:SetSize(readerWindow:GetWidth()-20,controlHeight)
	readerWindow.Story:SetFont(Settings.Font)
	readerWindow.Story:SetText(readerWindow.Story:GetText())
	readerWindow.Chapter:SetTop(readerWindow.Story:GetTop()+readerWindow.Story:GetHeight()+5)
	readerWindow.Chapter:SetSize(readerWindow:GetWidth()-20,controlHeight)
	readerWindow.Chapter:SetFont(Settings.Font)
	readerWindow.Chapter:SetText(readerWindow.Chapter:GetText())

	readerWindow.Split:SetPosition(Settings.ReaderSplit*readerWindow:GetWidth(),readerWindow.Chapter:GetTop()+readerWindow.Chapter:GetHeight()+5) -- split is a percent
	readerWindow.Split:SetHeight(readerWindow:GetHeight()-readerWindow.Split:GetTop()-controlHeight-15)

	readerWindow.TextBorder:SetTop(readerWindow.Split:GetTop())
	readerWindow.TextBorder:SetSize(readerWindow.Split:GetLeft()-readerWindow.TextBorder:GetLeft()-11,readerWindow.Split:GetHeight())
	readerWindow.Text:SetSize(readerWindow.TextBorder:GetWidth()-2,readerWindow.TextBorder:GetHeight()-2)

	fontMetric:SetFont(Settings.Font)
	for k=1,readerWindow.Text:GetItemCount() do
		local tmpItem=readerWindow.Text:GetItem(k)
		tmpItem:SetWidth(readerWindow.Text:GetWidth())
		if tmpItem.Type=="Text" then
			tmpItem:SetHeight(fontMetric:GetTextHeight(tmpItem:GetText(),readerWindow.Text:GetWidth()))
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetText(tmpItem:GetText())
		elseif tmpItem.Type=="Image" then
			if readerWindow.Text:GetWidth()>=tmpItem.Image.Width then
				tmpItem.Image:SetBackground(tmpItem.Image.File)
				tmpItem.Image:SetSize(tmpItem.Image.Width,tmpItem.Image.Height)
				tmpItem:SetHeight(tmpItem.Image.Height)
			else
				tmpItem.Image:SetBackground(resourcePath.."ImageIcon.tga")
				tmpItem.Image:SetSize(32,32)
				tmpItem:SetHeight(32)
			end
			tmpItem.Image:SetLeft((readerWindow.Text:GetWidth()-tmpItem.Image:GetWidth())/2)
		end
	end
	readerWindow.TextVScroll:SetPosition(readerWindow.TextBorder:GetLeft()+readerWindow.TextBorder:GetWidth(),readerWindow.TextBorder:GetTop())
	readerWindow.TextVScroll:SetHeight(readerWindow.TextBorder:GetHeight())

	readerWindow.ObjectiveBorder:SetPosition(readerWindow.Split:GetLeft()+readerWindow.Split:GetWidth()+3,readerWindow.TextBorder:GetTop())
	readerWindow.ObjectiveBorder:SetSize(readerWindow:GetWidth()-readerWindow.ObjectiveBorder:GetLeft()-22,readerWindow.Text:GetHeight())
	readerWindow.ObjectiveList:SetSize(readerWindow.ObjectiveBorder:GetWidth()-2,readerWindow.ObjectiveBorder:GetHeight()-2)
	readerWindow.ObjectiveListVScroll:SetPosition(readerWindow.ObjectiveBorder:GetLeft()+readerWindow.ObjectiveBorder:GetWidth(),readerWindow.ObjectiveBorder:GetTop())
	readerWindow.ObjectiveListVScroll:SetHeight(readerWindow.ObjectiveList:GetHeight())

	readerWindow.PausedMessage:SetSize(readerWindow.ObjectiveBorder:GetWidth()+10,readerWindow.ObjectiveBorder:GetHeight())
	readerWindow.PausedMessage:SetPosition(readerWindow.ObjectiveBorder:GetPosition())
	readerWindow.PausedMessage:SetFont(Settings.Font)
	readerWindow.PausedMessage:SetText(readerWindow.PausedMessage:GetText())
	readerWindow.Message:SetTop(readerWindow:GetHeight()-controlHeight-10)
	readerWindow.Message:SetSize(readerWindow:GetWidth()-readerWindow.Message:GetLeft()*2,controlHeight)
	readerWindow.Message:SetFont(Settings.Font)
	readerWindow.Message:SetText(readerWindow.Message:GetText())
	readerWindow.MouseMask:SetSize(readerWindow:GetSize())

	local objWidth=readerWindow.ObjectiveList:GetWidth()
	for k=1,readerWindow.ObjectiveList:GetItemCount() do
		local tmpItem=readerWindow.ObjectiveList:GetItem(k)
		local height2=0
		fontMetric:SetFont(Settings.Font)
		local height=fontMetric:GetTextHeight(tmpItem:GetText(),objWidth)
		if tmpItem.CheckMark~=nil then
			-- add checkmark 1091437784
			tmpItem.CheckMark:SetPosition(0,height)
			height2=tmpItem.CheckMark:GetHeight()
		end
		if tmpItem.Button~=nil then
			tmpItem.Button:SetPosition((objWidth-tmpItem.Button:GetWidth())/2,height)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(tmpItem.Button:GetText())+20)
			tmpItem.Button:SetText(tmpItem.Button:GetText())
			height2=tmpItem.Button:GetHeight()
		end
		height=height+height2
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetText(tmpItem:GetText())
		tmpItem:SetSize(objWidth,height+controlHeight)
		
	end
end
readerWindow.RefreshLayout()
readerWindow.SizeChanged=function(sernder,args)
	readerWindow.RefreshLayout()
end
readerWindow.RefreshColor=function()
	readerWindow.Story:SetForeColor(Settings.LabelColor)
	readerWindow.Chapter:SetForeColor(Settings.LabelColor)
	readerWindow.Split:SetBackColor(Settings.TrimColor)
	readerWindow.TextBorder:SetBackColor(Settings.TrimColor)
	readerWindow.Text:SetBackColor(Settings.BackColor)
	readerWindow.ObjectiveBorder:SetBackColor(Settings.TrimColor)
	readerWindow.ObjectiveList:SetBackColor(Settings.BackColor)
end
readerWindow.RefreshColor()

readerWindow.StorySelected=function()
	SaveSetting("Account",pluginName.."Settings","","ReaderStoryID",storySelect.SelectedID) -- save story id
	SaveSetting("Account",pluginName.."Settings","","Mode","Reader") -- trigger reload
	SaveSettings()
	SettingQueueCallback(loadMenu)
end
SaveSettings=function()
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","LastStory",readerWindow.currentStoryID)
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","Width",readerWindow:GetWidth()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","Height",readerWindow:GetHeight()/displayHeight)
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","Top",readerWindow:GetTop()/displayHeight)
	SaveSetting("Account",pluginName.."Settings","ReaderWindow","Left",readerWindow:GetLeft()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Left",iconWindow:GetLeft()/displayWidth)
	SaveSetting("Account",pluginName.."Settings","IconWindow","Top",iconWindow:GetTop()/displayHeight)
end
readerCheckTimeStamps=function()
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	if index~=nil and StoryList[index].ActiveChapter~=nil then
		-- check timestamps
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		local lastEdit=readerStory.LastEditTime
		if lastEdit==nil then lastEdit=0 end -- should only happen with test files
		local lastRead=StoryList[index].LastReadTime
		if lastRead~=nil and lastEdit>lastRead then
			readerWindow.MouseMask:SetMouseVisible(true)
			confirmReset=PopUpDialog(Resource[language][110],Resource[language][111],4,Resource[language][86],Resource[language][87],nil,false,readerOfferReset)
		else
			readerDisplayStory()
		end
	else
		readerDisplayStory()
	end
end
readerOfferReset=function(flag)
	readerWindow.MouseMask:SetMouseVisible(false)
	confirmReset=nil
	if flag==1 then
		readerWindow.ActiveChapter=nil
		local index=getStoryIndexFromID(readerWindow.currentStoryID)
		StoryList[index].ActiveChapter=nil
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayStory()
		readerWindow.Message:SetText(Resource[language][79])
	else
		readerDisplayStory()
	end
end
readerDisplayStory=function()
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	readerWindow.MouseMask:SetMouseVisible(false)
	local tmp=""
	if readerStory.Author~=nil then tmp=tmp..readerStory.Author end
	if readerStory.Name~=nil then tmp=tmp..": "..readerStory.Name end
	if readerStory.Chapters==nil then readerStory.Chapters={} end
	readerWindow.Story:SetText(tmp)
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	readerWindow.ActiveChapter=StoryList[index].ActiveChapter
	readerWindow.ObjectiveList:ClearItems()
	readerWindow.Text:ClearItems()
	if readerWindow.ActiveChapter~=nil then
		readerDisplayActiveChapter()
	else
		readerWindow.Chapter:SetText("")
		local tmpItem=Turbine.UI.Label()
		tmpItem:SetParent(readerWindow.Text)
		local tmpText=resolveText(readerStory.Desc)
		tmpItem:SetFont(Settings.Font)
		fontMetric:SetFont(Settings.Font)
		tmpItem:SetSize(readerWindow.Text:GetWidth(),fontMetric:GetTextHeight(tmpText,readerWindow.Text:GetWidth()))
		tmpItem:SetForeColor(Settings.FontColor)
		tmpItem:SetText(tmpText)
		readerWindow.Text:AddItem(tmpItem)
		-- find first chapter
		local first
		for k,v in pairs(readerStory.Chapters) do
			if v.DisplayOrder==1 then
				first=k
				break
			end
		end
		-- add a "Start Story" button
		if first~=nil then
			local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
			local tmpItem=Turbine.UI.Label()
			tmpItem:SetParent(readerWindow.Objectives)
			tmpItem:SetFont(Settings.Font)
			tmpItem:SetWidth(readerWindow.ObjectiveList:GetWidth())
			fontMetric:SetFont(Settings.Font)
			local height=fontMetric:GetTextHeight(Resource[language][76],tmpItem:GetWidth())
			tmpItem:SetText(Resource[language][76])
			tmpItem.MouseClick=function() readerStartStory(first) end
			tmpItem.Button=Turbine.UI.Lotro.Button()
			tmpItem.Button:SetParent(tmpItem)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(Resource[language][77])+20)
			tmpItem.Button:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.Button:GetWidth())/2,height)
			tmpItem.Button:SetText(Resource[language][77])
			tmpItem.Button.Click=function() readerStartStory(first) end
			tmpItem:SetHeight(height+20+controlHeight)
			readerWindow.ObjectiveList:AddItem(tmpItem)
		end
	end
	readerWindow.Message:SetText(Resource[language][24])
end
readerSetImage=function(control)
	local tmpImage=Turbine.UI.Control() -- use a temp image to get size since using SetStretchMode causes image to draw outside it's owner even after set back to 0
	-- generate an image
	local imageFile=control.ImagePath
	if imageFile~="" then
		if string.sub(imageFile,-1)~="/" then
			imageFile=imageFile.."/"
		end
	end
	local tmpName=control.FileName
	if imageFile=="" and tonumber(tmpName)~=nil and tonumber(tmpName)>0 then
		imageFile=tonumber(tmpName)
	else
		imageFile=imageFile..control.FileName
	end
	local success,result=pcall(Turbine.UI.Control.SetBackground,tmpImage,imageFile)
	if success then
		control.File=imageFile
		control:SetVisible(true)
		tmpImage:SetStretchMode(2)
		control.Width,control.Height=tmpImage:GetSize()
		if control.Width>readerWindow.Text:GetWidth() then
			-- image is too big, show icon
			control:SetBackground(resourcePath.."ImageIcon.tga")
			control:SetSize(32,32)
		else
			control:SetBackground(imageFile)
			control:SetSize(control.Width,control.Height)
		end
	else
		control.File=resourcePath.."ImageError.tga"
		control:SetBackground(resourcePath.."ImageError.tga")
		control:SetSize(32,32)
		control.Width=32
		control.Height=32
	end
	control:GetParent():SetHeight(control:GetHeight())
	control:SetLeft((readerWindow.Text:GetWidth()-control:GetWidth())/2)
end
readerDisplayActiveChapter=function()
	-- remove all active callbacks
	for k,v in pairs(readerWindow.Callbacks) do
		RemoveCallback(v.Object,v.Event,v.Function)
		readerWindow.Callbacks[k]=nil
	end
	readerWindow.Callbacks={}
	readerWindow.Text:ClearItems()
	if readerWindow.ActiveChapter~=nil then
		readerWindow.Chapter:SetText(readerStory.Chapters[readerWindow.ActiveChapter].Name)
		for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Content) do
			local newHeight=controlHeight
			local newWidth=readerWindow.Text:GetWidth()
			local item
			if v.Type=="Text" then
				item=Turbine.UI.Label()
				item:SetSelectable(true)
				item:SetForeColor(Settings.FontColor)
				item:SetFont(Settings.Font)
				item:SetMultiline(true)
				if v.Text~=nil then
					local tmpText=resolveText(v.Text)
					item:SetText(resolveText(tmpText))
					newHeight=fontMetric:GetTextHeight(tmpText,newWidth)
				else
					item:SetText("")
				end
			elseif v.Type=="Image" then
				item=Turbine.UI.Control()
				item:SetWidth(newWidth)
				item.Image=Turbine.UI.Control()
				item.Image:SetParent(item)
				item.Image:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				item.Image:SetMouseVisible(false)
				item.Image.ImagePath=v.Path
				item.Image.FileName=v.FileName
				if v.Path~=nil and v.FileName~=nil then
					readerSetImage(item.Image)
					if item.Image.Width>newWidth then
						newHeight=32
					else
						newHeight=item.Image.Height
					end
				else
					item.Image.File=resourcePath.."ImageError.tga"
					item.Image:SetBackground(resourcePath.."ImageError.tga")
					item.Image:SetSize(32,32)
					item.Image.Width=32
					item.Image.Height=32
					newHeight=32
					item.Image:SetLeft((newWidth-item.Image:GetWidth())/2)
				end
				item.MouseDoubleClick=function(sender,args)
					imageViewer.ShowImage(sender.Image.ImagePath,sender.Image.FileName)
				end
			end
--			item.MouseDown=function(sender,args)
--				chapterMaint.Content:SetSelectedItem(sender)
--			end
--			item.MouseClick=function(sender,args)
--				if args.Button==2 then
--					local x,y=Turbine.UI.Display:GetMousePosition()
--					chapterMaint.ContentMenu:ShowMenuAt(x+2,y+15)
--				end
--			end
			item.Index=k
			item:SetParent(readerWindow.Text)
			item.Type=v.Type
			item.Text=v.Text
			item.FileName=v.FileName
			item.Path=v.Path

			item:SetSize(newWidth,newHeight)
			readerWindow.Text:AddItem(item)
		end
--		readerWindow.Text:SetText(resolveText(readerStory.Chapters[readerWindow.ActiveChapter].Text))
		-- reevaluate all objective statuses
		readerDisplayActiveObjectiveList()

		-- now add callbacks for the current chapter's objectives
		local addTargetCallback=false
		for k,v in pairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
			if v.Type=="Target" then
				addTargetCallback=true
			end
		end
		if addTargetCallback then
			table.insert(readerWindow.Callbacks,{["Object"]=localPlayer,["Event"]="TargetChanged",["Function"]=readerWindow.TargetChanged})
			AddCallback(localPlayer,"TargetChanged",readerWindow.TargetChanged)
		end
		--fire TargetChanged in case we already have a target
		readerWindow.TargetChanged()
	end
	readerWindow.Message:SetText("")
end
readerStartStory=function(firstChapter)
	readerWindow.ActiveChapter=firstChapter
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	StoryList[index].ActiveChapter=firstChapter
	StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
	-- need to indicate that we are resetting
	readerWindow.Message:SetText("Setting Status. One Moment...")
	readerWindow.ObjectiveList:ClearItems()
	-- reset all objective statuses
	for k,v in ipairs(readerStory.Chapters) do
		if v.Objectives~=nil then
			for i,obj in pairs(v.Objectives) do
				if type(obj)=="table" then
					-- update cached copy
					obj.Count=nil
					obj.Status=nil
				end
			end
		end
	end
	local cmd="if tmpData.Chapters~=nil then for chapterIndex,chapter in ipairs(tmpData.Chapters) do chapter.Status=false; if chapter.Objectives~=nil then for objIndex,objective in ipairs(chapter.Objectives) do objective.Count=nil;objective.Status=false end end end end"
	SettingQueueCommand("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),cmd,nil,nil)
	-- need to use callback to delay until status updates take effect
	SettingQueueCallback(readerDisplayActiveChapter)
end
readerDisplayActiveObjectiveList=function()
	local controlHeight=Turbine.UI.Lotro.FontInfo[Settings.Font].size+4
	local buttonFont=Settings.Font
	while Turbine.UI.Lotro.FontInfo[buttonFont].size>22 do
		-- make sure button text fits on buttons since they don't size larger than 20 pixels (22 is ok since lotro font sizes are off a bit)
		buttonFont=GetSmallerFont(buttonFont)
	end

	readerWindow.ObjectiveList:ClearItems()
	tmpList={}
	for k,v in ipairs(readerStory.Chapters[readerWindow.ActiveChapter].Objectives) do
		table.insert(tmpList,{["ID"]=k,["Name"]=v.Name,["Type"]=v.Type,["Status"]=v.Status,["Count"]=v.Count,["Required Count"]=v.RequiredCount,["DisplayOrder"]=v.DisplayOrder,["ObjectiveString"]=v.ObjectiveString,["Text"]=v.Text})
	end
	table.sort(tmpList,function(arg1,arg2) if arg1.DisplayOrder<arg2.DisplayOrder then return true end end)
	for k,v in ipairs(tmpList) do
		-- create the text
		local tmpText=resolveText(v.Text)
		if v.Type==4 or v.Type==5 or v.Type==6 then
			tmpText=tmpText+"\n["..tostring(v.Count).."/"..tostring(v.RequiredCount).."]"
		end
		local tmpItem=Turbine.UI.Label()
		tmpItem:SetParent(readerWindow.Objectives)
		tmpItem:SetFont(Settings.Font)
		tmpItem:SetWidth(readerWindow.ObjectiveList:GetWidth())
		fontMetric:SetFont(Settings.Font)
		local height=fontMetric:GetTextHeight(tmpText,tmpItem:GetWidth())
		local height2=0
		tmpItem:SetText(tmpText)
		if v.Status then
			-- create checkmark 1091437784
			tmpItem.CheckMark=Turbine.UI.Control()
			tmpItem.CheckMark:SetParent(tmpItem)
			tmpItem.CheckMark:SetSize(24,18)
			tmpItem.CheckMark:SetBlendMode(Turbine.UI.BlendMode.Overlay)
			tmpItem.CheckMark:SetBackground(1091437784)
			height2=18
		end
		if v.Type=="Button" then
			-- create /loc quickslot
			tmpItem.Button=Turbine.UI.Lotro.Button()
			tmpItem.Button:SetParent(tmpItem)
			tmpItem.Button:SetFont(buttonFont)
			fontMetric:SetFont(buttonFont)
			tmpItem.Button:SetWidth(fontMetric:GetTextWidth(v.Name)+20)
			tmpItem.Button:SetPosition((readerWindow.ObjectiveList:GetWidth()-tmpItem.Button:GetWidth())/2,height)
			tmpItem.Button:SetText(v.ObjectiveString)
			tmpItem.Button.Click=function() local next=readerUpdateObjectiveStatus(readerWindow.ActiveChapter,v.ID);if next==nil then readerUpdateChapterStatus() else readerGoToChapter(next) end end
			height2=20
		end
		tmpItem:SetHeight(height+height2+controlHeight)
		readerWindow.ObjectiveList:AddItem(tmpItem)
	end
end
readerUpdateObjectiveStatus=function(chapter,obj)
	local update=false
	local nextChapter=nil
	if chapter==nil then chapter=readerWindow.ActiveChapter end
	-- update depends on type of objective
	local objective=readerStory.Chapters[chapter].Objectives[obj]
	if objective.Type=="Button" then
		objective.Status=true
		update=true
		nextChapter=objective.NextChapter -- objectives can optionally change chapter immediately on completion or combine
	elseif objective.Type=="Target" then
		local tmpTarget=localPlayer:GetTarget()
		if tmpTarget~=nil then
			if tmpTarget:GetName()==resolveText(objective.ObjectiveString) then
				objective.Status=true
				update=true
				nextChapter=objective.NextChapter -- objectives can optionally change chapter immediately on completion or combine
			end
		end
	end
	if update then
		SaveSetting("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),"Chapters_#"..tostring(chapter).."_Objectives_#"..tostring(obj),"Status",readerStory.Chapters[chapter].Objectives[obj].Status)
	end
	SaveSetting("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),"Chapters_#"..tostring(readerWindow.ActiveChapter),"Status",(nextChapter~=nil))
	return nextChapter
end
readerUpdateChapterStatus=function()
 -- check for success condition and if all objectives are met, then move on to next chapter
	local condition=readerStory.Chapters[readerWindow.ActiveChapter].SuccessCondition
	local status=false
	if condition~=nil then
		if type(condition)=="number" then
			status=readerStory.Chapters[readerWindow.ActiveChapter].Objectives[condition].Status
		elseif type(condition)=="table" then
			status=true
			for k,v in ipairs(condition) do
				status=(status and readerStory.Chapters[readerWindow.ActiveChapter].Objectives[v].Status)
			end
		end
	end
	if status then
		readerStory.Chapters[readerWindow.ActiveChapter].Status=true
		SaveSetting("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),"Chapters_#"..tostring(readerWindow.ActiveChapter),"Status",true)
		readerGoToChapter(readerStory.Chapters[readerWindow.ActiveChapter].SuccessNextChapter)
	else
		condition=readerStory.Chapters[readerWindow.ActiveChapter].FailCondition
		if condition~=nil then
			if type(condition)=="number" then
				status=readerStory.Chapters[readerWindow.ActiveChapter].Objectives[condition].Status
			elseif type(condition)=="table" then
				status=true
				for k,v in ipairs(condition) do
					status=(status and readerStory.Chapters[readerWindow.ActiveChapter].Objectives[v].Status)
				end
			end
		end
		readerStory.Chapters[readerWindow.ActiveChapter].Status=status
		SaveSetting("Account",pluginName.."Story"..tostring(readerWindow.currentStoryID),"Chapters_#"..tostring(readerWindow.ActiveChapter),"Status",status)
		if status then
			readerGoToChapter(readerStory.Chapters[readerWindow.ActiveChapter].FailNextChapter)
		else
			readerDisplayActiveObjectiveList()
			readerWindow.RefreshLayout()
		end
	end
	return status
end
readerGoToChapter=function(chapter)
--Turbine.Shell.WriteLine("going to chapter:"..tostring(chapter))
	readerWindow.ActiveChapter=chapter
	local index=getStoryIndexFromID(readerWindow.currentStoryID)
	if readerWindow.ActiveChapter>0 then
		StoryList[index].ActiveChapter=readerWindow.ActiveChapter
		StoryList[index].LastReadTime=Turbine.Engine:GetLocalTime()
		readerDisplayActiveChapter()
	else
		StoryList[index].ActiveChapter=nil
		readerDisplayStory()
	end
end
readerWindow.StoryDeleted=function(ID)
	if readerWindow.currentStoryID==ID then
		readerWindow.currentStoryID=nil
		if not readerWindow.Paused then
			for k,v in pairs(readerWindow.Callbacks) do
				RemoveCallback(v.Object,v.Event,v.Function)
			end
		else
			readerWindow.Paused=false
			readerWindow.LoadButton:SetEnabled(true)
			readerWindow.ResetButton:SetEnabled(true)
			readerWindow.HistoryButton:SetEnabled(true)
		end
		readerWindow.Story:SetText("")
		readerWindow.Chapter:SetText("")
		readerWindow.Text:ClearItems()
		readerWindow.ObjectiveList:ClearItems()
	end
end

-- OBJECTIVE CALLBACKS
readerWindow.TargetChanged=function()
	-- registered for TargetChanged
	if readerWindow.ActiveChapter~=nil then
		local objectives=readerStory.Chapters[readerWindow.ActiveChapter].Objectives
		if objectives~=nil then
			for k,v in pairs(objectives) do
				if v.Type=="Target" then
					local next=readerUpdateObjectiveStatus(readerWindow.ActiveStory,k)
					if next==nil then
						if readerUpdateChapterStatus() then break end
					else
						readerGoToChapter(next)
						break
					end
				end
			end
		end
	end
end
readerWindow.InventoryChanged=function()
-- registered for backpack:ItemAdded, ItemRemoved, and ItemMoved
end
readerWindow.MessageReceived=function()
-- killed x of y
-- pattern match
-- emote
end
readerWindow.EquipmentChanged=function()
-- registered for ItemEquipped and ItemUnequipped
end
readerWindow.EffectsChanged=function()
	-- registered for EffectAdded, EffectRemoved and EffectsCleared
end
readerWindow.WalletChanged=function()
	-- registered for Wallet:ItemAdded, ItemRemoved
end
readerWindow.CloseInfo=function()
	readerWindow.MouseMask:SetMouseVisible(false)
	infoPopUp=nil
end
readerWindow.CloseError=function()
	readerWindow.MouseMask:SetMouseVisible(false)
	errorMsg=nil
end
readerWindow:SetVisible(true)
currentWindow=readerWindow

unloadMain=function()
	success,result=pcall(Turbine.PluginManager.UnloadScriptState,"Anthology");
end
SettingQueueCallback(unloadMain)
plugin.Unload=function()
	-- remove callbacks
	for k,v in pairs(readerWindow.Callbacks) do
		RemoveCallback(v.Object,v.Event,v.Function)
	end
	--save storylist
	PatchDataSave( Turbine.DataScope.Account, pluginName.."StoryList",StoryList);
end
resolveText=function(string)
	if string==nil then
		string=""
	else
		-- @PlayerName
		string=string.gsub(string,"@PlayerName",localPlayer.Name)
		-- @Target
		local target=localPlayer:GetTarget()
		if tarbet~=nil then
			string=string.gsub(string,"@Target",target:GetName())
		else
			string=string.gsub(string,"@Target","??")
		end
		-- @PlayerClass
		string=string.gsub(string,"@PlayerClass",localPlayer.ClassName)
		-- @PlayerRace
		string=string.gsub(string,"@PlayerRace",localPlayer.RaceName)
	end
	return string
end
-- show current story
if readerWindow.currentStoryID~=nil and readerWindow.currentStoryID>0 then
	readerCheckTimeStamps()
end
